/* FileUtility.c generated by valac 0.30.0, the Vala compiler
 * generated from FileUtility.vala, do not modify */

/*
 * DayJournal
 *
 * Copyright (C) 2013 Zach Burnham <thejambi@gmail.com>
 *
 * DayJournal is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * DayJournal is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <stdio.h>


#define TYPE_FILE_UTILITY (file_utility_get_type ())
#define FILE_UTILITY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_UTILITY, FileUtility))
#define FILE_UTILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_UTILITY, FileUtilityClass))
#define IS_FILE_UTILITY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_UTILITY))
#define IS_FILE_UTILITY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_UTILITY))
#define FILE_UTILITY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_UTILITY, FileUtilityClass))

typedef struct _FileUtility FileUtility;
typedef struct _FileUtilityClass FileUtilityClass;
typedef struct _FileUtilityPrivate FileUtilityPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _FileUtility {
	GObject parent_instance;
	FileUtilityPrivate * priv;
};

struct _FileUtilityClass {
	GObjectClass parent_class;
};


static gpointer file_utility_parent_class = NULL;

GType file_utility_get_type (void) G_GNUC_CONST;
enum  {
	FILE_UTILITY_DUMMY_PROPERTY
};
void file_utility_createFolder (const gchar* dirPath);
gchar* file_utility_getFileExtension (GFileInfo* file);
gchar* file_utility_getFileExtensionFromString (const gchar* fileName);
gchar* file_utility_getNewStyleBlipDay (const gchar* filename);
gchar* file_utility_getFileNameWithoutExtension (const gchar* fileName);
void zystem_debug (const gchar* s);
gboolean file_utility_isImageFile (GFileInfo* file);
gboolean file_utility_isDirectoryEmpty (const gchar* dirPath);
gchar* file_utility_pathCombine (const gchar* pathStart, const gchar* pathEnd);
gboolean file_utility_isDirectory (const gchar* path);
gchar* file_utility_addTimestampToFilePath (const gchar* filePath);
gchar* file_utility_getPathFromImgTag (const gchar* imgTag);
void file_utility_convertToNewJournalStructure (void);
const gchar* user_data_get_djDirPath (void);
static void file_utility_recurseDirForNaming (const gchar* path, GFileInfo* dir, GError** error);
FileUtility* file_utility_new (void);
FileUtility* file_utility_construct (GType object_type);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Create a folder (or make sure it exists).
 */
void file_utility_createFolder (const gchar* dirPath) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (dirPath != NULL);
	_tmp0_ = dirPath;
	g_mkdir_with_parents (_tmp0_, 0775);
}


/**
 * Return the file extension from the given fileInfo.
 */
gchar* file_utility_getFileExtension (GFileInfo* file) {
	gchar* result = NULL;
	gchar* fileName = NULL;
	GFileInfo* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	_tmp0_ = file;
	_tmp1_ = g_file_info_get_name (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	fileName = _tmp2_;
	_tmp3_ = file_utility_getFileExtensionFromString (fileName);
	result = _tmp3_;
	_g_free0 (fileName);
	return result;
}


/**
 * Return the file extension from the given string filename.
 */
static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_ = 0L;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_ = 0L;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		_tmp3_ = offset;
		_tmp4_ = len;
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
		string_length = _tmp5_;
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		_tmp6_ = strlen (self);
		_tmp7_ = _tmp6_;
		string_length = (glong) _tmp7_;
	}
	_tmp8_ = offset;
	if (_tmp8_ < ((glong) 0)) {
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp9_ = string_length;
		_tmp10_ = offset;
		offset = _tmp9_ + _tmp10_;
		_tmp11_ = offset;
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
		_tmp12_ = offset;
		_tmp13_ = string_length;
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
	}
	_tmp14_ = len;
	if (_tmp14_ < ((glong) 0)) {
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
		_tmp15_ = string_length;
		_tmp16_ = offset;
		len = _tmp15_ - _tmp16_;
	}
	_tmp17_ = offset;
	_tmp18_ = len;
	_tmp19_ = string_length;
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
	_tmp20_ = offset;
	_tmp21_ = len;
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
	result = _tmp22_;
	return result;
}


static gint string_last_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = start_index;
	_tmp1_ = needle;
	_tmp2_ = g_strrstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_ = NULL;
		_tmp4_ = _result_;
		result = (gint) (_tmp4_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


gchar* file_utility_getFileExtensionFromString (const gchar* fileName) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (fileName != NULL, NULL);
	_tmp0_ = fileName;
	_tmp1_ = fileName;
	_tmp2_ = string_last_index_of (_tmp1_, ".", 0);
	_tmp3_ = string_substring (_tmp0_, (glong) _tmp2_, (glong) -1);
	result = _tmp3_;
	return result;
}


gchar* file_utility_getNewStyleBlipDay (const gchar* filename) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	_tmp0_ = filename;
	_tmp1_ = string_substring (_tmp0_, (glong) 0, (glong) 2);
	result = _tmp1_;
	return result;
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_ = 0L;
	glong _tmp16_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	g_return_val_if_fail (_tmp8_, NULL);
	_tmp13_ = end;
	if (_tmp13_ >= ((glong) 0)) {
		glong _tmp14_ = 0L;
		glong _tmp15_ = 0L;
		_tmp14_ = end;
		_tmp15_ = string_length;
		_tmp12_ = _tmp14_ <= _tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp16_ = start;
	_tmp17_ = end;
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	_tmp20_ = start;
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
	result = _tmp21_;
	return result;
}


static gint string_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = start_index;
	_tmp1_ = needle;
	_tmp2_ = strstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_ = NULL;
		_tmp4_ = _result_;
		result = (gint) (_tmp4_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


gchar* file_utility_getFileNameWithoutExtension (const gchar* fileName) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	g_return_val_if_fail (fileName != NULL, NULL);
	_tmp0_ = fileName;
	_tmp1_ = fileName;
	_tmp2_ = fileName;
	_tmp3_ = file_utility_getFileExtensionFromString (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = string_index_of (_tmp1_, _tmp4_, 0);
	_tmp6_ = string_slice (_tmp0_, (glong) 0, (glong) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat ("FILENAMEWITHOUTEXTENSION ", _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	zystem_debug (_tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp4_);
	_tmp10_ = fileName;
	_tmp11_ = fileName;
	_tmp12_ = fileName;
	_tmp13_ = file_utility_getFileExtensionFromString (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = string_index_of (_tmp11_, _tmp14_, 0);
	_tmp16_ = string_slice (_tmp10_, (glong) 0, (glong) _tmp15_);
	_tmp17_ = _tmp16_;
	_g_free0 (_tmp14_);
	result = _tmp17_;
	return result;
}


/**
 * Return true if FileInfo represents an image file.
 */
gboolean file_utility_isImageFile (GFileInfo* file) {
	gboolean result = FALSE;
	gchar* ext = NULL;
	GFileInfo* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_ = NULL;
	g_return_val_if_fail (file != NULL, FALSE);
	_tmp0_ = file;
	_tmp1_ = file_utility_getFileExtension (_tmp0_);
	ext = _tmp1_;
	_tmp4_ = ext;
	if (g_strcmp0 (_tmp4_, ".jpg") == 0) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_ = NULL;
		_tmp5_ = ext;
		_tmp3_ = g_strcmp0 (_tmp5_, ".png") == 0;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp6_ = NULL;
		_tmp6_ = ext;
		_tmp2_ = g_strcmp0 (_tmp6_, ".gif") == 0;
	}
	result = _tmp2_;
	_g_free0 (ext);
	return result;
}


/**
 * 
 */
gboolean file_utility_isDirectoryEmpty (const gchar* dirPath) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (dirPath != NULL, FALSE);
	{
		GFile* directory = NULL;
		const gchar* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_ = NULL;
		GFileInfo* file_info = NULL;
		_tmp0_ = dirPath;
		_tmp1_ = g_file_new_for_path (_tmp0_);
		directory = _tmp1_;
		_tmp2_ = directory;
		_tmp3_ = g_file_enumerate_children (_tmp2_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
		enumerator = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (directory);
			goto __catch3_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp4_ = NULL;
			GFileEnumerator* _tmp5_ = NULL;
			GFileInfo* _tmp6_ = NULL;
			GFileInfo* _tmp7_ = NULL;
			_tmp5_ = enumerator;
			_tmp6_ = g_file_enumerator_next_file (_tmp5_, NULL, &_inner_error_);
			_tmp4_ = _tmp6_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (file_info);
				_g_object_unref0 (enumerator);
				_g_object_unref0 (directory);
				goto __catch3_g_error;
			}
			_tmp7_ = _tmp4_;
			_tmp4_ = NULL;
			_g_object_unref0 (file_info);
			file_info = _tmp7_;
			if (!(file_info != NULL)) {
				_g_object_unref0 (_tmp4_);
				break;
			}
			zystem_debug ("Directory is not empty");
			result = FALSE;
			_g_object_unref0 (_tmp4_);
			_g_object_unref0 (file_info);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (directory);
			return result;
		}
		zystem_debug ("Directory is empty");
		result = TRUE;
		_g_object_unref0 (file_info);
		_g_object_unref0 (enumerator);
		_g_object_unref0 (directory);
		return result;
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		FILE* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = stderr;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		fprintf (_tmp8_, "Error: %s\n", _tmp10_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally3:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return FALSE;
}


gchar* file_utility_pathCombine (const gchar* pathStart, const gchar* pathEnd) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (pathStart != NULL, NULL);
	g_return_val_if_fail (pathEnd != NULL, NULL);
	_tmp0_ = pathStart;
	_tmp1_ = pathEnd;
	_tmp2_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, _tmp1_, NULL);
	result = _tmp2_;
	return result;
}


gboolean file_utility_isDirectory (const gchar* path) {
	gboolean result = FALSE;
	GFile* dir = NULL;
	const gchar* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = path;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	dir = _tmp1_;
	{
		GFileInfo* fileInfo = NULL;
		GFileInfo* _tmp2_ = NULL;
		GFileType _tmp3_ = 0;
		_tmp2_ = g_file_query_info (dir, "*", 0, NULL, &_inner_error_);
		fileInfo = _tmp2_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch4_g_error;
		}
		_tmp3_ = g_file_info_get_file_type (fileInfo);
		result = _tmp3_ == G_FILE_TYPE_DIRECTORY;
		_g_object_unref0 (fileInfo);
		_g_object_unref0 (dir);
		return result;
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		result = FALSE;
		_g_error_free0 (e);
		_g_object_unref0 (dir);
		return result;
	}
	__finally4:
	_g_object_unref0 (dir);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return FALSE;
}


/**
 * Get the file path with the unique timestamp inserted at end of 
 * filename before file extension.
 */
gchar* file_utility_addTimestampToFilePath (const gchar* filePath) {
	gchar* result = NULL;
	GDateTime* dateTime = NULL;
	GDateTime* _tmp0_ = NULL;
	gchar* pathPrefix = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gchar* _tmp4_ = NULL;
	gchar* fileExt = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gchar* _tmp8_ = NULL;
	gchar* timestamp = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	g_return_val_if_fail (filePath != NULL, NULL);
	_tmp0_ = g_date_time_new_now_local ();
	dateTime = _tmp0_;
	_tmp1_ = filePath;
	_tmp2_ = filePath;
	_tmp3_ = string_last_index_of (_tmp2_, ".", 0);
	_tmp4_ = string_substring (_tmp1_, (glong) 0, (glong) _tmp3_);
	pathPrefix = _tmp4_;
	_tmp5_ = filePath;
	_tmp6_ = filePath;
	_tmp7_ = string_last_index_of (_tmp6_, ".", 0);
	_tmp8_ = string_substring (_tmp5_, (glong) _tmp7_, (glong) -1);
	fileExt = _tmp8_;
	_tmp9_ = g_date_time_format (dateTime, "_%Y%m%d_%H%M%S");
	timestamp = _tmp9_;
	_tmp10_ = g_strconcat (pathPrefix, timestamp, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, fileExt, NULL);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp11_);
	result = _tmp13_;
	_g_free0 (timestamp);
	_g_free0 (fileExt);
	_g_free0 (pathPrefix);
	_g_date_time_unref0 (dateTime);
	return result;
}


gchar* file_utility_getPathFromImgTag (const gchar* imgTag) {
	gchar* result = NULL;
	gchar* textICareAbout = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar* _tmp3_ = NULL;
	gchar** chunks = NULL;
	gchar** _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	gint chunks_length1 = 0;
	gint _chunks_size_ = 0;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	g_return_val_if_fail (imgTag != NULL, NULL);
	_tmp0_ = imgTag;
	_tmp1_ = imgTag;
	_tmp2_ = string_index_of (_tmp1_, "src='", 0);
	_tmp3_ = string_substring (_tmp0_, (glong) _tmp2_, (glong) -1);
	textICareAbout = _tmp3_;
	_tmp5_ = _tmp4_ = g_strsplit (textICareAbout, "'", 0);
	chunks = _tmp5_;
	chunks_length1 = _vala_array_length (_tmp4_);
	_chunks_size_ = chunks_length1;
	_tmp6_ = chunks[1];
	_tmp7_ = g_strdup (_tmp6_);
	result = _tmp7_;
	chunks = (_vala_array_free (chunks, chunks_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (textICareAbout);
	return result;
}


void file_utility_convertToNewJournalStructure (void) {
	GError * _inner_error_ = NULL;
	zystem_debug ("Converting journal directory");
	{
		GFile* djDir = NULL;
		const gchar* _tmp0_ = NULL;
		const gchar* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp3_ = NULL;
		GFileEnumerator* _tmp4_ = NULL;
		GFileInfo* fileInfo = NULL;
		_tmp0_ = user_data_get_djDirPath ();
		_tmp1_ = _tmp0_;
		_tmp2_ = g_file_new_for_path (_tmp1_);
		djDir = _tmp2_;
		_tmp3_ = djDir;
		_tmp4_ = g_file_enumerate_children (_tmp3_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
		enumerator = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (djDir);
			goto __catch5_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp5_ = NULL;
			GFileEnumerator* _tmp6_ = NULL;
			GFileInfo* _tmp7_ = NULL;
			GFileInfo* _tmp8_ = NULL;
			GFileInfo* _tmp9_ = NULL;
			GFileInfo* _tmp10_ = NULL;
			GFileType _tmp11_ = 0;
			_tmp6_ = enumerator;
			_tmp7_ = g_file_enumerator_next_file (_tmp6_, NULL, &_inner_error_);
			_tmp5_ = _tmp7_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (fileInfo);
				_g_object_unref0 (enumerator);
				_g_object_unref0 (djDir);
				goto __catch5_g_error;
			}
			_tmp8_ = _tmp5_;
			_tmp5_ = NULL;
			_g_object_unref0 (fileInfo);
			fileInfo = _tmp8_;
			_tmp9_ = fileInfo;
			if (!(_tmp9_ != NULL)) {
				_g_object_unref0 (_tmp5_);
				break;
			}
			_tmp10_ = fileInfo;
			_tmp11_ = g_file_info_get_file_type (_tmp10_);
			if (_tmp11_ == G_FILE_TYPE_DIRECTORY) {
				const gchar* _tmp12_ = NULL;
				const gchar* _tmp13_ = NULL;
				GFileInfo* _tmp14_ = NULL;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
				GFileInfo* _tmp18_ = NULL;
				_tmp12_ = user_data_get_djDirPath ();
				_tmp13_ = _tmp12_;
				_tmp14_ = fileInfo;
				_tmp15_ = g_file_info_get_name (_tmp14_);
				_tmp16_ = file_utility_pathCombine (_tmp13_, _tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = fileInfo;
				file_utility_recurseDirForNaming (_tmp17_, _tmp18_, &_inner_error_);
				_g_free0 (_tmp17_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (_tmp5_);
					_g_object_unref0 (fileInfo);
					_g_object_unref0 (enumerator);
					_g_object_unref0 (djDir);
					goto __catch5_g_error;
				}
			}
			_g_object_unref0 (_tmp5_);
		}
		_g_object_unref0 (fileInfo);
		_g_object_unref0 (enumerator);
		_g_object_unref0 (djDir);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		FILE* _tmp19_ = NULL;
		GError* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp19_ = stderr;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		fprintf (_tmp19_, "Error in DayFolder.cleanDesktop(): %s\n", _tmp21_);
		_g_error_free0 (e);
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void file_utility_recurseDirForNaming (const gchar* path, GFileInfo* dir, GError** error) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GFile* fileObject = NULL;
	const gchar* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp5_ = NULL;
	GFileEnumerator* _tmp6_ = NULL;
	GFileInfo* file = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (path != NULL);
	g_return_if_fail (dir != NULL);
	_tmp0_ = path;
	_tmp1_ = g_strconcat ("Recursing dir: ", _tmp0_, NULL);
	_tmp2_ = _tmp1_;
	zystem_debug (_tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = path;
	_tmp4_ = g_file_new_for_path (_tmp3_);
	fileObject = _tmp4_;
	_tmp5_ = fileObject;
	_tmp6_ = g_file_enumerate_children (_tmp5_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
	enumerator = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (fileObject);
		return;
	}
	while (TRUE) {
		GFileInfo* _tmp7_ = NULL;
		GFileEnumerator* _tmp8_ = NULL;
		GFileInfo* _tmp9_ = NULL;
		GFileInfo* _tmp10_ = NULL;
		GFileInfo* _tmp11_ = NULL;
		GFileInfo* _tmp12_ = NULL;
		GFileType _tmp13_ = 0;
		_tmp8_ = enumerator;
		_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (file);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (fileObject);
			return;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		_g_object_unref0 (file);
		file = _tmp10_;
		_tmp11_ = file;
		if (!(_tmp11_ != NULL)) {
			_g_object_unref0 (_tmp7_);
			break;
		}
		_tmp12_ = file;
		_tmp13_ = g_file_info_get_file_type (_tmp12_);
		if (_tmp13_ == G_FILE_TYPE_DIRECTORY) {
			GFileInfo* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gint _tmp17_ = 0;
			_tmp14_ = file;
			_tmp15_ = g_file_info_get_name (_tmp14_);
			_tmp16_ = strlen (_tmp15_);
			_tmp17_ = _tmp16_;
			if (_tmp17_ == 4) {
				const gchar* _tmp18_ = NULL;
				GFileInfo* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				gchar* _tmp22_ = NULL;
				GFileInfo* _tmp23_ = NULL;
				_tmp18_ = path;
				_tmp19_ = file;
				_tmp20_ = g_file_info_get_name (_tmp19_);
				_tmp21_ = file_utility_pathCombine (_tmp18_, _tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = file;
				file_utility_recurseDirForNaming (_tmp22_, _tmp23_, &_inner_error_);
				_g_free0 (_tmp22_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					g_propagate_error (error, _inner_error_);
					_g_object_unref0 (_tmp7_);
					_g_object_unref0 (file);
					_g_object_unref0 (enumerator);
					_g_object_unref0 (fileObject);
					return;
				}
			} else {
				GFileInfo* _tmp24_ = NULL;
				const gchar* _tmp25_ = NULL;
				gint _tmp26_ = 0;
				gint _tmp27_ = 0;
				_tmp24_ = file;
				_tmp25_ = g_file_info_get_name (_tmp24_);
				_tmp26_ = strlen (_tmp25_);
				_tmp27_ = _tmp26_;
				if (_tmp27_ == 1) {
					gchar* filePath = NULL;
					const gchar* _tmp28_ = NULL;
					GFileInfo* _tmp29_ = NULL;
					const gchar* _tmp30_ = NULL;
					gchar* _tmp31_ = NULL;
					const gchar* _tmp32_ = NULL;
					gchar* _tmp33_ = NULL;
					gchar* _tmp34_ = NULL;
					const gchar* _tmp35_ = NULL;
					GFileInfo* _tmp36_ = NULL;
					const gchar* _tmp37_ = NULL;
					gchar* _tmp38_ = NULL;
					gchar* _tmp39_ = NULL;
					gchar* _tmp40_ = NULL;
					gchar* _tmp41_ = NULL;
					gchar* _tmp42_ = NULL;
					gchar* _tmp43_ = NULL;
					const gchar* _tmp44_ = NULL;
					const gchar* _tmp45_ = NULL;
					GFileInfo* _tmp46_ = NULL;
					const gchar* _tmp47_ = NULL;
					gchar* _tmp48_ = NULL;
					gchar* _tmp49_ = NULL;
					gchar* _tmp50_ = NULL;
					gchar* _tmp51_ = NULL;
					const gchar* _tmp52_ = NULL;
					GFileInfo* _tmp53_ = NULL;
					const gchar* _tmp54_ = NULL;
					gchar* _tmp55_ = NULL;
					gchar* _tmp56_ = NULL;
					gchar* _tmp57_ = NULL;
					gchar* _tmp58_ = NULL;
					GFileInfo* _tmp59_ = NULL;
					_tmp28_ = path;
					_tmp29_ = file;
					_tmp30_ = g_file_info_get_name (_tmp29_);
					_tmp31_ = file_utility_pathCombine (_tmp28_, _tmp30_);
					filePath = _tmp31_;
					_tmp32_ = filePath;
					_tmp33_ = g_strconcat ("Should rename : ", _tmp32_, NULL);
					_tmp34_ = _tmp33_;
					zystem_debug (_tmp34_);
					_g_free0 (_tmp34_);
					_tmp35_ = path;
					_tmp36_ = file;
					_tmp37_ = g_file_info_get_name (_tmp36_);
					_tmp38_ = g_strconcat ("0", _tmp37_, NULL);
					_tmp39_ = _tmp38_;
					_tmp40_ = file_utility_pathCombine (_tmp35_, _tmp39_);
					_tmp41_ = _tmp40_;
					_tmp42_ = g_strconcat ("::::       to : ", _tmp41_, NULL);
					_tmp43_ = _tmp42_;
					zystem_debug (_tmp43_);
					_g_free0 (_tmp43_);
					_g_free0 (_tmp41_);
					_g_free0 (_tmp39_);
					_tmp44_ = filePath;
					_tmp45_ = path;
					_tmp46_ = file;
					_tmp47_ = g_file_info_get_name (_tmp46_);
					_tmp48_ = g_strconcat ("0", _tmp47_, NULL);
					_tmp49_ = _tmp48_;
					_tmp50_ = file_utility_pathCombine (_tmp45_, _tmp49_);
					_tmp51_ = _tmp50_;
					g_rename (_tmp44_, _tmp51_);
					_g_free0 (_tmp51_);
					_g_free0 (_tmp49_);
					_tmp52_ = path;
					_tmp53_ = file;
					_tmp54_ = g_file_info_get_name (_tmp53_);
					_tmp55_ = g_strconcat ("0", _tmp54_, NULL);
					_tmp56_ = _tmp55_;
					_tmp57_ = file_utility_pathCombine (_tmp52_, _tmp56_);
					_tmp58_ = _tmp57_;
					_tmp59_ = file;
					file_utility_recurseDirForNaming (_tmp58_, _tmp59_, &_inner_error_);
					_g_free0 (_tmp58_);
					_g_free0 (_tmp56_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						g_propagate_error (error, _inner_error_);
						_g_free0 (filePath);
						_g_object_unref0 (_tmp7_);
						_g_object_unref0 (file);
						_g_object_unref0 (enumerator);
						_g_object_unref0 (fileObject);
						return;
					}
					_g_free0 (filePath);
				} else {
					GFileInfo* _tmp60_ = NULL;
					const gchar* _tmp61_ = NULL;
					gint _tmp62_ = 0;
					gint _tmp63_ = 0;
					_tmp60_ = file;
					_tmp61_ = g_file_info_get_name (_tmp60_);
					_tmp62_ = strlen (_tmp61_);
					_tmp63_ = _tmp62_;
					if (_tmp63_ == 2) {
						const gchar* _tmp64_ = NULL;
						GFileInfo* _tmp65_ = NULL;
						const gchar* _tmp66_ = NULL;
						gchar* _tmp67_ = NULL;
						gchar* _tmp68_ = NULL;
						GFileInfo* _tmp69_ = NULL;
						_tmp64_ = path;
						_tmp65_ = file;
						_tmp66_ = g_file_info_get_name (_tmp65_);
						_tmp67_ = file_utility_pathCombine (_tmp64_, _tmp66_);
						_tmp68_ = _tmp67_;
						_tmp69_ = file;
						file_utility_recurseDirForNaming (_tmp68_, _tmp69_, &_inner_error_);
						_g_free0 (_tmp68_);
						if (G_UNLIKELY (_inner_error_ != NULL)) {
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (_tmp7_);
							_g_object_unref0 (file);
							_g_object_unref0 (enumerator);
							_g_object_unref0 (fileObject);
							return;
						}
					}
				}
			}
		} else {
			gboolean _tmp70_ = FALSE;
			gboolean _tmp71_ = FALSE;
			GFileInfo* _tmp72_ = NULL;
			GFileType _tmp73_ = 0;
			_tmp72_ = file;
			_tmp73_ = g_file_info_get_file_type (_tmp72_);
			if (_tmp73_ == G_FILE_TYPE_REGULAR) {
				GFileInfo* _tmp74_ = NULL;
				const gchar* _tmp75_ = NULL;
				gint _tmp76_ = 0;
				gint _tmp77_ = 0;
				_tmp74_ = file;
				_tmp75_ = g_file_info_get_name (_tmp74_);
				_tmp76_ = strlen (_tmp75_);
				_tmp77_ = _tmp76_;
				_tmp71_ = _tmp77_ == 5;
			} else {
				_tmp71_ = FALSE;
			}
			if (_tmp71_) {
				GFileInfo* _tmp78_ = NULL;
				gchar* _tmp79_ = NULL;
				gchar* _tmp80_ = NULL;
				_tmp78_ = file;
				_tmp79_ = file_utility_getFileExtension (_tmp78_);
				_tmp80_ = _tmp79_;
				_tmp70_ = g_strcmp0 (_tmp80_, ".txt") == 0;
				_g_free0 (_tmp80_);
			} else {
				_tmp70_ = FALSE;
			}
			if (_tmp70_) {
				gchar* filePath = NULL;
				const gchar* _tmp81_ = NULL;
				GFileInfo* _tmp82_ = NULL;
				const gchar* _tmp83_ = NULL;
				gchar* _tmp84_ = NULL;
				const gchar* _tmp85_ = NULL;
				gchar* _tmp86_ = NULL;
				gchar* _tmp87_ = NULL;
				const gchar* _tmp88_ = NULL;
				GFileInfo* _tmp89_ = NULL;
				const gchar* _tmp90_ = NULL;
				GFileInfo* _tmp91_ = NULL;
				const gchar* _tmp92_ = NULL;
				gint _tmp93_ = 0;
				gchar* _tmp94_ = NULL;
				gchar* _tmp95_ = NULL;
				gchar* _tmp96_ = NULL;
				gchar* _tmp97_ = NULL;
				gchar* _tmp98_ = NULL;
				gchar* _tmp99_ = NULL;
				gchar* _tmp100_ = NULL;
				gchar* _tmp101_ = NULL;
				gchar* _tmp102_ = NULL;
				gchar* _tmp103_ = NULL;
				const gchar* _tmp104_ = NULL;
				const gchar* _tmp105_ = NULL;
				GFileInfo* _tmp106_ = NULL;
				const gchar* _tmp107_ = NULL;
				GFileInfo* _tmp108_ = NULL;
				const gchar* _tmp109_ = NULL;
				gint _tmp110_ = 0;
				gchar* _tmp111_ = NULL;
				gchar* _tmp112_ = NULL;
				gchar* _tmp113_ = NULL;
				gchar* _tmp114_ = NULL;
				gchar* _tmp115_ = NULL;
				gchar* _tmp116_ = NULL;
				gchar* _tmp117_ = NULL;
				gchar* _tmp118_ = NULL;
				_tmp81_ = path;
				_tmp82_ = file;
				_tmp83_ = g_file_info_get_name (_tmp82_);
				_tmp84_ = file_utility_pathCombine (_tmp81_, _tmp83_);
				filePath = _tmp84_;
				_tmp85_ = filePath;
				_tmp86_ = g_strconcat ("Should rename : ", _tmp85_, NULL);
				_tmp87_ = _tmp86_;
				zystem_debug (_tmp87_);
				_g_free0 (_tmp87_);
				_tmp88_ = path;
				_tmp89_ = file;
				_tmp90_ = g_file_info_get_name (_tmp89_);
				_tmp91_ = file;
				_tmp92_ = g_file_info_get_name (_tmp91_);
				_tmp93_ = string_last_index_of (_tmp92_, ".", 0);
				_tmp94_ = string_substring (_tmp90_, (glong) 0, (glong) _tmp93_);
				_tmp95_ = _tmp94_;
				_tmp96_ = g_strconcat ("0", _tmp95_, NULL);
				_tmp97_ = _tmp96_;
				_tmp98_ = file_utility_pathCombine (_tmp88_, _tmp97_);
				_tmp99_ = _tmp98_;
				_tmp100_ = g_strconcat ("::::       to : ", _tmp99_, NULL);
				_tmp101_ = _tmp100_;
				_tmp102_ = g_strconcat (_tmp101_, ".txt", NULL);
				_tmp103_ = _tmp102_;
				zystem_debug (_tmp103_);
				_g_free0 (_tmp103_);
				_g_free0 (_tmp101_);
				_g_free0 (_tmp99_);
				_g_free0 (_tmp97_);
				_g_free0 (_tmp95_);
				_tmp104_ = filePath;
				_tmp105_ = path;
				_tmp106_ = file;
				_tmp107_ = g_file_info_get_name (_tmp106_);
				_tmp108_ = file;
				_tmp109_ = g_file_info_get_name (_tmp108_);
				_tmp110_ = string_last_index_of (_tmp109_, ".", 0);
				_tmp111_ = string_substring (_tmp107_, (glong) 0, (glong) _tmp110_);
				_tmp112_ = _tmp111_;
				_tmp113_ = g_strconcat ("0", _tmp112_, NULL);
				_tmp114_ = _tmp113_;
				_tmp115_ = file_utility_pathCombine (_tmp105_, _tmp114_);
				_tmp116_ = _tmp115_;
				_tmp117_ = g_strconcat (_tmp116_, ".txt", NULL);
				_tmp118_ = _tmp117_;
				g_rename (_tmp104_, _tmp118_);
				_g_free0 (_tmp118_);
				_g_free0 (_tmp116_);
				_g_free0 (_tmp114_);
				_g_free0 (_tmp112_);
				_g_free0 (filePath);
			}
		}
		_g_object_unref0 (_tmp7_);
	}
	_g_object_unref0 (file);
	_g_object_unref0 (enumerator);
	_g_object_unref0 (fileObject);
}


FileUtility* file_utility_construct (GType object_type) {
	FileUtility * self = NULL;
	self = (FileUtility*) g_object_new (object_type, NULL);
	return self;
}


FileUtility* file_utility_new (void) {
	return file_utility_construct (TYPE_FILE_UTILITY);
}


static void file_utility_class_init (FileUtilityClass * klass) {
	file_utility_parent_class = g_type_class_peek_parent (klass);
}


static void file_utility_instance_init (FileUtility * self) {
}


/**
 * File Utility class.
 */
GType file_utility_get_type (void) {
	static volatile gsize file_utility_type_id__volatile = 0;
	if (g_once_init_enter (&file_utility_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FileUtilityClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_utility_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileUtility), 0, (GInstanceInitFunc) file_utility_instance_init, NULL };
		GType file_utility_type_id;
		file_utility_type_id = g_type_register_static (G_TYPE_OBJECT, "FileUtility", &g_define_type_info, 0);
		g_once_init_leave (&file_utility_type_id__volatile, file_utility_type_id);
	}
	return file_utility_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



