/* JournalArchiver.c generated by valac 0.30.0, the Vala compiler
 * generated from JournalArchiver.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; intend-tabs-mode: t -*- */
/*
 * DayJournal
 *
 * Copyright (C) 2013 Zach Burnham <thejambi@gmail.com>
 *
 * DayJournal is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * DayJournal is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <stdio.h>


#define TYPE_JOURNAL_ARCHIVER (journal_archiver_get_type ())
#define JOURNAL_ARCHIVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_JOURNAL_ARCHIVER, JournalArchiver))
#define JOURNAL_ARCHIVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_JOURNAL_ARCHIVER, JournalArchiverClass))
#define IS_JOURNAL_ARCHIVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_JOURNAL_ARCHIVER))
#define IS_JOURNAL_ARCHIVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_JOURNAL_ARCHIVER))
#define JOURNAL_ARCHIVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_JOURNAL_ARCHIVER, JournalArchiverClass))

typedef struct _JournalArchiver JournalArchiver;
typedef struct _JournalArchiverClass JournalArchiverClass;
typedef struct _JournalArchiverPrivate JournalArchiverPrivate;

#define TYPE_YEAR_FOLDER (year_folder_get_type ())
#define YEAR_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_YEAR_FOLDER, YearFolder))
#define YEAR_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_YEAR_FOLDER, YearFolderClass))
#define IS_YEAR_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_YEAR_FOLDER))
#define IS_YEAR_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_YEAR_FOLDER))
#define YEAR_FOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_YEAR_FOLDER, YearFolderClass))

typedef struct _YearFolder YearFolder;
typedef struct _YearFolderClass YearFolderClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_MONTH_FOLDER (month_folder_get_type ())
#define MONTH_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONTH_FOLDER, MonthFolder))
#define MONTH_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MONTH_FOLDER, MonthFolderClass))
#define IS_MONTH_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONTH_FOLDER))
#define IS_MONTH_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MONTH_FOLDER))
#define MONTH_FOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MONTH_FOLDER, MonthFolderClass))

typedef struct _MonthFolder MonthFolder;
typedef struct _MonthFolderClass MonthFolderClass;

#define TYPE_JOURNAL_ENTRY (journal_entry_get_type ())
#define JOURNAL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_JOURNAL_ENTRY, JournalEntry))
#define JOURNAL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_JOURNAL_ENTRY, JournalEntryClass))
#define IS_JOURNAL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_JOURNAL_ENTRY))
#define IS_JOURNAL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_JOURNAL_ENTRY))
#define JOURNAL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_JOURNAL_ENTRY, JournalEntryClass))

typedef struct _JournalEntry JournalEntry;
typedef struct _JournalEntryClass JournalEntryClass;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _YearFolderPrivate YearFolderPrivate;
typedef struct _MonthFolderPrivate MonthFolderPrivate;

struct _JournalArchiver {
	GObject parent_instance;
	JournalArchiverPrivate * priv;
};

struct _JournalArchiverClass {
	GObjectClass parent_class;
};

struct _JournalArchiverPrivate {
	GeeMap* yearFolders;
	gchar* _archiveFilePath;
	gchar* _archiveFilePathMonthly;
	gchar* _archiveDirPathMonthly;
	gchar* archiveType;
};

struct _YearFolder {
	GObject parent_instance;
	YearFolderPrivate * priv;
};

struct _YearFolderClass {
	GObjectClass parent_class;
};

struct _YearFolderPrivate {
	gint _year;
	GeeMap* _monthMap;
};

struct _MonthFolder {
	GObject parent_instance;
	MonthFolderPrivate * priv;
};

struct _MonthFolderClass {
	GObjectClass parent_class;
};

struct _MonthFolderPrivate {
	gint _month;
	GeeMap* _entryMap;
};


static gpointer journal_archiver_parent_class = NULL;
static gpointer year_folder_parent_class = NULL;
static gpointer month_folder_parent_class = NULL;

GType journal_archiver_get_type (void) G_GNUC_CONST;
GType year_folder_get_type (void) G_GNUC_CONST;
#define JOURNAL_ARCHIVER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_JOURNAL_ARCHIVER, JournalArchiverPrivate))
enum  {
	JOURNAL_ARCHIVER_DUMMY_PROPERTY,
	JOURNAL_ARCHIVER_ARCHIVE_FILE_PATH,
	JOURNAL_ARCHIVER_ARCHIVE_FILE_PATH_MONTHLY,
	JOURNAL_ARCHIVER_ARCHIVE_DIR_PATH_MONTHLY
};
#define JOURNAL_ARCHIVER_TYPE_HTML "html"
#define JOURNAL_ARCHIVER_TYPE_TEXT "txt"
JournalArchiver* journal_archiver_new (const gchar* type);
JournalArchiver* journal_archiver_construct (GType object_type, const gchar* type);
static void journal_archiver_set_archiveFilePath (JournalArchiver* self, const gchar* value);
void journal_archiver_createCompleteArchiveFile (JournalArchiver* self);
void zystem_debug (const gchar* s);
static void journal_archiver_setCompleteArchiveFilename (JournalArchiver* self);
gchar* user_data_getArchiveDirPath (void);
void file_utility_createFolder (const gchar* dirPath);
static void journal_archiver_beginHtmlArchiveFile (JournalArchiver* self);
const gchar* user_data_get_djDirPath (void);
static void journal_archiver_processYearDir (JournalArchiver* self, GFileInfo* yearDirInfo, GFile* yearDir);
static void journal_archiver_writeEntriesToArchiveFile (JournalArchiver* self);
static void journal_archiver_endHtmlArchiveFile (JournalArchiver* self);
YearFolder* year_folder_new (GFileInfo* fileInfo);
YearFolder* year_folder_construct (GType object_type, GFileInfo* fileInfo);
static void journal_archiver_processMonthDir (JournalArchiver* self, YearFolder* yearFolder, GFileInfo* monthDirInfo, GFile* monthDir);
static void journal_archiver_setMonthlyArchiveDirPath (JournalArchiver* self, gint year);
gint year_folder_get_year (YearFolder* self);
static void journal_archiver_setMonthlyArchiveFilename (JournalArchiver* self, gint year, const gchar* month);
static void journal_archiver_beginHtmlMonthlyArchiveFile (JournalArchiver* self);
GType month_folder_get_type (void) G_GNUC_CONST;
MonthFolder* month_folder_new (GFileInfo* fileInfo);
MonthFolder* month_folder_construct (GType object_type, GFileInfo* fileInfo);
GType journal_entry_get_type (void) G_GNUC_CONST;
JournalEntry* journal_entry_new (gint year, gint month, gint day);
JournalEntry* journal_entry_construct (GType object_type, gint year, gint month, gint day);
void month_folder_addEntry (MonthFolder* self, gint day, JournalEntry* entry);
static void journal_archiver_writeMonthlyEntriesToArchiveFile (JournalArchiver* self, MonthFolder* monthFolder);
void year_folder_addMonth (YearFolder* self, gint monthNum, MonthFolder* monthFolder);
gchar* file_utility_pathCombine (const gchar* pathStart, const gchar* pathEnd);
const gchar* journal_archiver_get_archiveFilePath (JournalArchiver* self);
static void journal_archiver_appendStringToArchiveFile (JournalArchiver* self, GFileOutputStream* fileStream, const gchar* text);
static gchar* journal_archiver_getMonthlyArchiveFilePath (JournalArchiver* self);
GeeMap* year_folder_get_monthMap (YearFolder* self);
GeeMap* month_folder_get_entryMap (MonthFolder* self);
static void journal_archiver_writeJournalEntry (JournalArchiver* self, GFileOutputStream* fileStream, JournalEntry* entry);
gint journal_entry_get_day (JournalEntry* self);
const gchar* journal_archiver_get_archiveDirPathMonthly (JournalArchiver* self);
const gchar* journal_archiver_get_archiveFilePathMonthly (JournalArchiver* self);
static void journal_archiver_set_archiveDirPathMonthly (JournalArchiver* self, const gchar* value);
static void journal_archiver_set_archiveFilePathMonthly (JournalArchiver* self, const gchar* value);
gint journal_entry_get_year (JournalEntry* self);
gint journal_entry_get_month (JournalEntry* self);
gchar* journal_entry_getFileContents (JournalEntry* self);
static guint8* _vala_array_dup1 (guint8* self, int length);
static guint8* _vala_array_dup2 (guint8* self, int length);
static void journal_archiver_finalize (GObject* obj);
static void _vala_journal_archiver_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_journal_archiver_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define YEAR_FOLDER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_YEAR_FOLDER, YearFolderPrivate))
enum  {
	YEAR_FOLDER_DUMMY_PROPERTY,
	YEAR_FOLDER_YEAR,
	YEAR_FOLDER_MONTH_MAP
};
static void year_folder_set_year (YearFolder* self, gint value);
static void year_folder_set_monthMap (YearFolder* self, GeeMap* value);
static void year_folder_finalize (GObject* obj);
static void _vala_year_folder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_year_folder_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define MONTH_FOLDER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MONTH_FOLDER, MonthFolderPrivate))
enum  {
	MONTH_FOLDER_DUMMY_PROPERTY,
	MONTH_FOLDER_MONTH,
	MONTH_FOLDER_ENTRY_MAP
};
static void month_folder_set_entryMap (MonthFolder* self, GeeMap* value);
static void month_folder_set_month (MonthFolder* self, gint value);
gint month_folder_get_month (MonthFolder* self);
static void month_folder_finalize (GObject* obj);
static void _vala_month_folder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_month_folder_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


JournalArchiver* journal_archiver_construct (GType object_type, const gchar* type) {
	JournalArchiver * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GeeTreeMap* _tmp2_ = NULL;
	g_return_val_if_fail (type != NULL, NULL);
	self = (JournalArchiver*) g_object_new (object_type, NULL);
	_tmp0_ = type;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->archiveType);
	self->priv->archiveType = _tmp1_;
	_tmp2_ = gee_tree_map_new (G_TYPE_INT, NULL, NULL, TYPE_YEAR_FOLDER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->yearFolders);
	self->priv->yearFolders = (GeeMap*) _tmp2_;
	journal_archiver_set_archiveFilePath (self, "");
	return self;
}


JournalArchiver* journal_archiver_new (const gchar* type) {
	return journal_archiver_construct (TYPE_JOURNAL_ARCHIVER, type);
}


void journal_archiver_createCompleteArchiveFile (JournalArchiver* self) {
	gchar* path = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	zystem_debug ("-----\nCREATING JOURNAL ARCHIVE FILE\n-----");
	journal_archiver_setCompleteArchiveFilename (self);
	_tmp0_ = user_data_getArchiveDirPath ();
	path = _tmp0_;
	_tmp1_ = path;
	file_utility_createFolder (_tmp1_);
	{
		const gchar* _tmp2_ = NULL;
		GFile* djDir = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp6_ = NULL;
		GFileEnumerator* _tmp7_ = NULL;
		GFileInfo* fileInfo = NULL;
		const gchar* _tmp21_ = NULL;
		_tmp2_ = self->priv->archiveType;
		if (g_strcmp0 (_tmp2_, "html") == 0) {
			journal_archiver_beginHtmlArchiveFile (self);
		}
		_tmp3_ = user_data_get_djDirPath ();
		_tmp4_ = _tmp3_;
		_tmp5_ = g_file_new_for_path (_tmp4_);
		djDir = _tmp5_;
		_tmp6_ = djDir;
		_tmp7_ = g_file_enumerate_children (_tmp6_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
		enumerator = _tmp7_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (djDir);
			goto __catch21_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp8_ = NULL;
			GFileEnumerator* _tmp9_ = NULL;
			GFileInfo* _tmp10_ = NULL;
			GFileInfo* _tmp11_ = NULL;
			GFileInfo* _tmp12_ = NULL;
			GFileInfo* _tmp13_ = NULL;
			GFileType _tmp14_ = 0;
			_tmp9_ = enumerator;
			_tmp10_ = g_file_enumerator_next_file (_tmp9_, NULL, &_inner_error_);
			_tmp8_ = _tmp10_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (fileInfo);
				_g_object_unref0 (enumerator);
				_g_object_unref0 (djDir);
				goto __catch21_g_error;
			}
			_tmp11_ = _tmp8_;
			_tmp8_ = NULL;
			_g_object_unref0 (fileInfo);
			fileInfo = _tmp11_;
			_tmp12_ = fileInfo;
			if (!(_tmp12_ != NULL)) {
				_g_object_unref0 (_tmp8_);
				break;
			}
			_tmp13_ = fileInfo;
			_tmp14_ = g_file_info_get_file_type (_tmp13_);
			if (_tmp14_ == G_FILE_TYPE_DIRECTORY) {
				GFile* subdir = NULL;
				GFile* _tmp15_ = NULL;
				GFileInfo* _tmp16_ = NULL;
				const gchar* _tmp17_ = NULL;
				GFile* _tmp18_ = NULL;
				GFileInfo* _tmp19_ = NULL;
				GFile* _tmp20_ = NULL;
				_tmp15_ = djDir;
				_tmp16_ = fileInfo;
				_tmp17_ = g_file_info_get_name (_tmp16_);
				_tmp18_ = g_file_resolve_relative_path (_tmp15_, _tmp17_);
				subdir = _tmp18_;
				_tmp19_ = fileInfo;
				_tmp20_ = subdir;
				journal_archiver_processYearDir (self, _tmp19_, _tmp20_);
				_g_object_unref0 (subdir);
			}
			_g_object_unref0 (_tmp8_);
		}
		journal_archiver_writeEntriesToArchiveFile (self);
		_tmp21_ = self->priv->archiveType;
		if (g_strcmp0 (_tmp21_, "html") == 0) {
			journal_archiver_endHtmlArchiveFile (self);
		}
		_g_object_unref0 (fileInfo);
		_g_object_unref0 (enumerator);
		_g_object_unref0 (djDir);
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* e = NULL;
		FILE* _tmp22_ = NULL;
		GError* _tmp23_ = NULL;
		const gchar* _tmp24_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp22_ = stderr;
		_tmp23_ = e;
		_tmp24_ = _tmp23_->message;
		fprintf (_tmp22_, "Error creating archive file. Error: %s\n", _tmp24_);
		_g_error_free0 (e);
	}
	__finally21:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (path);
}


static void journal_archiver_processYearDir (JournalArchiver* self, GFileInfo* yearDirInfo, GFile* yearDir) {
	GFileInfo* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GFileInfo* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	YearFolder* yearFolder = NULL;
	GFileInfo* _tmp7_ = NULL;
	YearFolder* _tmp8_ = NULL;
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp9_ = NULL;
	GFileEnumerator* _tmp10_ = NULL;
	GFileInfo* fileInfo = NULL;
	GeeMap* _tmp25_ = NULL;
	GFileInfo* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	gint _tmp28_ = 0;
	YearFolder* _tmp29_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (yearDirInfo != NULL);
	g_return_if_fail (yearDir != NULL);
	_tmp0_ = yearDirInfo;
	_tmp1_ = g_file_info_get_name (_tmp0_);
	_tmp2_ = g_regex_match_simple ("[0-9][0-9][0-9][0-9]", _tmp1_, 0, 0);
	if (!_tmp2_) {
		return;
	}
	_tmp3_ = yearDirInfo;
	_tmp4_ = g_file_info_get_name (_tmp3_);
	_tmp5_ = g_strconcat ("I found a year folder for ", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	zystem_debug (_tmp6_);
	_g_free0 (_tmp6_);
	_tmp7_ = yearDirInfo;
	_tmp8_ = year_folder_new (_tmp7_);
	yearFolder = _tmp8_;
	_tmp9_ = yearDir;
	_tmp10_ = g_file_enumerate_children (_tmp9_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
	enumerator = _tmp10_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (yearFolder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	while (TRUE) {
		GFileInfo* _tmp11_ = NULL;
		GFileEnumerator* _tmp12_ = NULL;
		GFileInfo* _tmp13_ = NULL;
		GFileInfo* _tmp14_ = NULL;
		GFileInfo* _tmp15_ = NULL;
		GFileInfo* _tmp16_ = NULL;
		GFileType _tmp17_ = 0;
		_tmp12_ = enumerator;
		_tmp13_ = g_file_enumerator_next_file (_tmp12_, NULL, &_inner_error_);
		_tmp11_ = _tmp13_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (fileInfo);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (yearFolder);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp14_ = _tmp11_;
		_tmp11_ = NULL;
		_g_object_unref0 (fileInfo);
		fileInfo = _tmp14_;
		_tmp15_ = fileInfo;
		if (!(_tmp15_ != NULL)) {
			_g_object_unref0 (_tmp11_);
			break;
		}
		_tmp16_ = fileInfo;
		_tmp17_ = g_file_info_get_file_type (_tmp16_);
		if (_tmp17_ == G_FILE_TYPE_DIRECTORY) {
			GFile* subdir = NULL;
			GFile* _tmp18_ = NULL;
			GFileInfo* _tmp19_ = NULL;
			const gchar* _tmp20_ = NULL;
			GFile* _tmp21_ = NULL;
			YearFolder* _tmp22_ = NULL;
			GFileInfo* _tmp23_ = NULL;
			GFile* _tmp24_ = NULL;
			_tmp18_ = yearDir;
			_tmp19_ = fileInfo;
			_tmp20_ = g_file_info_get_name (_tmp19_);
			_tmp21_ = g_file_resolve_relative_path (_tmp18_, _tmp20_);
			subdir = _tmp21_;
			_tmp22_ = yearFolder;
			_tmp23_ = fileInfo;
			_tmp24_ = subdir;
			journal_archiver_processMonthDir (self, _tmp22_, _tmp23_, _tmp24_);
			_g_object_unref0 (subdir);
		}
		_g_object_unref0 (_tmp11_);
	}
	_tmp25_ = self->priv->yearFolders;
	_tmp26_ = yearDirInfo;
	_tmp27_ = g_file_info_get_name (_tmp26_);
	_tmp28_ = atoi (_tmp27_);
	_tmp29_ = yearFolder;
	gee_map_set (_tmp25_, (gpointer) ((gintptr) _tmp28_), _tmp29_);
	_g_object_unref0 (fileInfo);
	_g_object_unref0 (enumerator);
	_g_object_unref0 (yearFolder);
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_ = 0L;
	glong _tmp16_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	g_return_val_if_fail (_tmp8_, NULL);
	_tmp13_ = end;
	if (_tmp13_ >= ((glong) 0)) {
		glong _tmp14_ = 0L;
		glong _tmp15_ = 0L;
		_tmp14_ = end;
		_tmp15_ = string_length;
		_tmp12_ = _tmp14_ <= _tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp16_ = start;
	_tmp17_ = end;
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	_tmp20_ = start;
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
	result = _tmp21_;
	return result;
}


static void journal_archiver_processMonthDir (JournalArchiver* self, YearFolder* yearFolder, GFileInfo* monthDirInfo, GFile* monthDir) {
	GFileInfo* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GFileInfo* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	YearFolder* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	YearFolder* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	GFileInfo* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	gint month = 0;
	GFileInfo* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	gint year = 0;
	YearFolder* _tmp18_ = NULL;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
	const gchar* _tmp21_ = NULL;
	MonthFolder* monthFolder = NULL;
	GFileInfo* _tmp22_ = NULL;
	MonthFolder* _tmp23_ = NULL;
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp24_ = NULL;
	GFileEnumerator* _tmp25_ = NULL;
	GFileInfo* fileInfo = NULL;
	MonthFolder* _tmp59_ = NULL;
	YearFolder* _tmp60_ = NULL;
	gint _tmp61_ = 0;
	MonthFolder* _tmp62_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (yearFolder != NULL);
	g_return_if_fail (monthDirInfo != NULL);
	g_return_if_fail (monthDir != NULL);
	_tmp0_ = monthDirInfo;
	_tmp1_ = g_file_info_get_name (_tmp0_);
	_tmp2_ = g_regex_match_simple ("[0-9][0-9]", _tmp1_, 0, 0);
	if (!_tmp2_) {
		return;
	}
	_tmp3_ = monthDirInfo;
	_tmp4_ = g_file_info_get_name (_tmp3_);
	_tmp5_ = g_strconcat ("I found a month folder for ", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	zystem_debug (_tmp6_);
	_g_free0 (_tmp6_);
	_tmp7_ = yearFolder;
	_tmp8_ = year_folder_get_year (_tmp7_);
	_tmp9_ = _tmp8_;
	journal_archiver_setMonthlyArchiveDirPath (self, _tmp9_);
	_tmp10_ = yearFolder;
	_tmp11_ = year_folder_get_year (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = monthDirInfo;
	_tmp14_ = g_file_info_get_name (_tmp13_);
	journal_archiver_setMonthlyArchiveFilename (self, _tmp12_, _tmp14_);
	_tmp15_ = monthDirInfo;
	_tmp16_ = g_file_info_get_name (_tmp15_);
	_tmp17_ = atoi (_tmp16_);
	month = _tmp17_;
	_tmp18_ = yearFolder;
	_tmp19_ = year_folder_get_year (_tmp18_);
	_tmp20_ = _tmp19_;
	year = _tmp20_;
	_tmp21_ = self->priv->archiveType;
	if (g_strcmp0 (_tmp21_, "html") == 0) {
		journal_archiver_beginHtmlMonthlyArchiveFile (self);
	}
	_tmp22_ = monthDirInfo;
	_tmp23_ = month_folder_new (_tmp22_);
	monthFolder = _tmp23_;
	_tmp24_ = monthDir;
	_tmp25_ = g_file_enumerate_children (_tmp24_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
	enumerator = _tmp25_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (monthFolder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	while (TRUE) {
		GFileInfo* _tmp26_ = NULL;
		GFileEnumerator* _tmp27_ = NULL;
		GFileInfo* _tmp28_ = NULL;
		GFileInfo* _tmp29_ = NULL;
		GFileInfo* _tmp30_ = NULL;
		gboolean _tmp31_ = FALSE;
		GFileInfo* _tmp32_ = NULL;
		GFileType _tmp33_ = 0;
		_tmp27_ = enumerator;
		_tmp28_ = g_file_enumerator_next_file (_tmp27_, NULL, &_inner_error_);
		_tmp26_ = _tmp28_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (fileInfo);
			_g_object_unref0 (enumerator);
			_g_object_unref0 (monthFolder);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp29_ = _tmp26_;
		_tmp26_ = NULL;
		_g_object_unref0 (fileInfo);
		fileInfo = _tmp29_;
		_tmp30_ = fileInfo;
		if (!(_tmp30_ != NULL)) {
			_g_object_unref0 (_tmp26_);
			break;
		}
		_tmp32_ = fileInfo;
		_tmp33_ = g_file_info_get_file_type (_tmp32_);
		if (_tmp33_ == G_FILE_TYPE_REGULAR) {
			GFileInfo* _tmp34_ = NULL;
			const gchar* _tmp35_ = NULL;
			gboolean _tmp36_ = FALSE;
			_tmp34_ = fileInfo;
			_tmp35_ = g_file_info_get_name (_tmp34_);
			_tmp36_ = g_regex_match_simple ("[0-9][0-9].txt", _tmp35_, 0, 0);
			_tmp31_ = _tmp36_;
		} else {
			_tmp31_ = FALSE;
		}
		if (_tmp31_) {
			GFileInfo* _tmp37_ = NULL;
			const gchar* _tmp38_ = NULL;
			gchar* _tmp39_ = NULL;
			gchar* _tmp40_ = NULL;
			gint day = 0;
			GFileInfo* _tmp41_ = NULL;
			const gchar* _tmp42_ = NULL;
			gchar* _tmp43_ = NULL;
			gchar* _tmp44_ = NULL;
			gint _tmp45_ = 0;
			gint _tmp46_ = 0;
			gint _tmp47_ = 0;
			gchar* _tmp48_ = NULL;
			gchar* _tmp49_ = NULL;
			gchar* _tmp50_ = NULL;
			gchar* _tmp51_ = NULL;
			JournalEntry* journalEntry = NULL;
			gint _tmp52_ = 0;
			gint _tmp53_ = 0;
			gint _tmp54_ = 0;
			JournalEntry* _tmp55_ = NULL;
			MonthFolder* _tmp56_ = NULL;
			gint _tmp57_ = 0;
			JournalEntry* _tmp58_ = NULL;
			_tmp37_ = fileInfo;
			_tmp38_ = g_file_info_get_name (_tmp37_);
			_tmp39_ = g_strconcat ("I hath found unto thee a journal entry file. It hath a name of: ", _tmp38_, NULL);
			_tmp40_ = _tmp39_;
			zystem_debug (_tmp40_);
			_g_free0 (_tmp40_);
			_tmp41_ = fileInfo;
			_tmp42_ = g_file_info_get_name (_tmp41_);
			_tmp43_ = string_slice (_tmp42_, (glong) 0, (glong) 2);
			_tmp44_ = _tmp43_;
			_tmp45_ = atoi (_tmp44_);
			_tmp46_ = _tmp45_;
			_g_free0 (_tmp44_);
			day = _tmp46_;
			_tmp47_ = day;
			_tmp48_ = g_strdup_printf ("%i", _tmp47_);
			_tmp49_ = _tmp48_;
			_tmp50_ = g_strconcat ("Here is the day: ", _tmp49_, NULL);
			_tmp51_ = _tmp50_;
			zystem_debug (_tmp51_);
			_g_free0 (_tmp51_);
			_g_free0 (_tmp49_);
			_tmp52_ = year;
			_tmp53_ = month;
			_tmp54_ = day;
			_tmp55_ = journal_entry_new (_tmp52_, _tmp53_, _tmp54_);
			journalEntry = _tmp55_;
			_tmp56_ = monthFolder;
			_tmp57_ = day;
			_tmp58_ = journalEntry;
			month_folder_addEntry (_tmp56_, _tmp57_, _tmp58_);
			_g_object_unref0 (journalEntry);
		}
		_g_object_unref0 (_tmp26_);
	}
	_tmp59_ = monthFolder;
	journal_archiver_writeMonthlyEntriesToArchiveFile (self, _tmp59_);
	_tmp60_ = yearFolder;
	_tmp61_ = month;
	_tmp62_ = monthFolder;
	year_folder_addMonth (_tmp60_, _tmp61_, _tmp62_);
	_g_object_unref0 (fileInfo);
	_g_object_unref0 (enumerator);
	_g_object_unref0 (monthFolder);
}


static void journal_archiver_beginHtmlArchiveFile (JournalArchiver* self) {
	gchar* path = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GFile* file = NULL;
	const gchar* _tmp4_ = NULL;
	GFile* _tmp5_ = NULL;
	GFileOutputStream* fileStream = NULL;
	GFileOutputStream* _tmp6_ = NULL;
	gchar* html = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = user_data_getArchiveDirPath ();
	path = _tmp0_;
	_tmp1_ = path;
	_tmp2_ = self->priv->_archiveFilePath;
	_tmp3_ = file_utility_pathCombine (_tmp1_, _tmp2_);
	_g_free0 (path);
	path = _tmp3_;
	_tmp4_ = path;
	_tmp5_ = g_file_new_for_path (_tmp4_);
	file = _tmp5_;
	_tmp6_ = g_file_append_to (file, G_FILE_CREATE_NONE, NULL, &_inner_error_);
	fileStream = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (file);
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp7_ = g_strdup ("<html><head><title>Complete Journal Archive</title> ");
	html = _tmp7_;
	_tmp8_ = html;
	_tmp9_ = g_strconcat (_tmp8_, "<style> ", NULL);
	_g_free0 (html);
	html = _tmp9_;
	_tmp10_ = html;
	_tmp11_ = g_strconcat (_tmp10_, "@media print { .entry { display: block; position: relative; page-break" \
"-inside:avoid; page-break-after: auto; } } ", NULL);
	_g_free0 (html);
	html = _tmp11_;
	_tmp12_ = html;
	_tmp13_ = g_strconcat (_tmp12_, "body { font-family: Ubuntu,'Droid Sans',Verdana,Geneva,sans-serif; fon" \
"t-size: 1em; } ", NULL);
	_g_free0 (html);
	html = _tmp13_;
	_tmp14_ = html;
	_tmp15_ = g_strconcat (_tmp14_, ".entry { margin: 1em 1em 2.5em 1em; line-height: 150%; border-top: 1px" \
" solid #555; } ", NULL);
	_g_free0 (html);
	html = _tmp15_;
	_tmp16_ = html;
	_tmp17_ = g_strconcat (_tmp16_, ".entryHeading { margin-left: 0.5em; margin-bottom: 0.7em; padding: 0 0" \
".7em 1.3em 0.3em; display: block; ", NULL);
	_g_free0 (html);
	html = _tmp17_;
	_tmp18_ = html;
	_tmp19_ = g_strconcat (_tmp18_, "float: right; font-size: 1.2em; border-left: 1px solid #555; line-heig" \
"ht: 90%; } ", NULL);
	_g_free0 (html);
	html = _tmp19_;
	_tmp20_ = html;
	_tmp21_ = g_strconcat (_tmp20_, ".dayjournalimage { max-width: 400px; max-height: 400px; } ", NULL);
	_g_free0 (html);
	html = _tmp21_;
	_tmp22_ = html;
	_tmp23_ = g_strconcat (_tmp22_, "</style> ", NULL);
	_g_free0 (html);
	html = _tmp23_;
	_tmp24_ = html;
	_tmp25_ = g_strconcat (_tmp24_, "</head><body> ", NULL);
	_g_free0 (html);
	html = _tmp25_;
	_tmp26_ = html;
	journal_archiver_appendStringToArchiveFile (self, fileStream, _tmp26_);
	_g_free0 (html);
	_g_object_unref0 (fileStream);
	_g_object_unref0 (file);
	_g_free0 (path);
}


static void journal_archiver_beginHtmlMonthlyArchiveFile (JournalArchiver* self) {
	gchar* path = NULL;
	gchar* _tmp0_ = NULL;
	GFile* file = NULL;
	GFile* _tmp1_ = NULL;
	GFileOutputStream* fileStream = NULL;
	GFileOutputStream* _tmp2_ = NULL;
	gchar* html = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = journal_archiver_getMonthlyArchiveFilePath (self);
	path = _tmp0_;
	_tmp1_ = g_file_new_for_path (path);
	file = _tmp1_;
	_tmp2_ = g_file_append_to (file, G_FILE_CREATE_NONE, NULL, &_inner_error_);
	fileStream = _tmp2_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (file);
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp3_ = g_strdup ("<html><head><title>Complete Journal Archive</title> ");
	html = _tmp3_;
	_tmp4_ = html;
	_tmp5_ = g_strconcat (_tmp4_, "<style> ", NULL);
	_g_free0 (html);
	html = _tmp5_;
	_tmp6_ = html;
	_tmp7_ = g_strconcat (_tmp6_, "@media print { .entry { display: block; position: relative; page-break" \
"-inside:avoid; page-break-after: auto; } } ", NULL);
	_g_free0 (html);
	html = _tmp7_;
	_tmp8_ = html;
	_tmp9_ = g_strconcat (_tmp8_, "body { font-family: Ubuntu,'Droid Sans',Verdana,Geneva,sans-serif; fon" \
"t-size: 1em; } ", NULL);
	_g_free0 (html);
	html = _tmp9_;
	_tmp10_ = html;
	_tmp11_ = g_strconcat (_tmp10_, ".entry { margin: 1em 1em 2.5em 1em; line-height: 150%; border-top: 1px" \
" solid #555; } ", NULL);
	_g_free0 (html);
	html = _tmp11_;
	_tmp12_ = html;
	_tmp13_ = g_strconcat (_tmp12_, ".entryHeading { margin-left: 0.5em; margin-bottom: 0.7em; padding: 0 0" \
".7em 1.3em 0.3em; display: block; ", NULL);
	_g_free0 (html);
	html = _tmp13_;
	_tmp14_ = html;
	_tmp15_ = g_strconcat (_tmp14_, "float: right; font-size: 1.2em; border-left: 1px solid #555; line-heig" \
"ht: 90%; } ", NULL);
	_g_free0 (html);
	html = _tmp15_;
	_tmp16_ = html;
	_tmp17_ = g_strconcat (_tmp16_, ".dayjournalimage { max-width: 400px; max-height: 400px; } ", NULL);
	_g_free0 (html);
	html = _tmp17_;
	_tmp18_ = html;
	_tmp19_ = g_strconcat (_tmp18_, "</style> ", NULL);
	_g_free0 (html);
	html = _tmp19_;
	_tmp20_ = html;
	_tmp21_ = g_strconcat (_tmp20_, "</head><body> ", NULL);
	_g_free0 (html);
	html = _tmp21_;
	_tmp22_ = html;
	journal_archiver_appendStringToArchiveFile (self, fileStream, _tmp22_);
	_g_free0 (html);
	_g_object_unref0 (fileStream);
	_g_object_unref0 (file);
	_g_free0 (path);
}


static void journal_archiver_endHtmlArchiveFile (JournalArchiver* self) {
	gchar* path = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GFile* file = NULL;
	const gchar* _tmp4_ = NULL;
	GFile* _tmp5_ = NULL;
	GFileOutputStream* fileStream = NULL;
	GFileOutputStream* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = user_data_getArchiveDirPath ();
	path = _tmp0_;
	_tmp1_ = path;
	_tmp2_ = self->priv->_archiveFilePath;
	_tmp3_ = file_utility_pathCombine (_tmp1_, _tmp2_);
	_g_free0 (path);
	path = _tmp3_;
	_tmp4_ = path;
	_tmp5_ = g_file_new_for_path (_tmp4_);
	file = _tmp5_;
	_tmp6_ = g_file_append_to (file, G_FILE_CREATE_NONE, NULL, &_inner_error_);
	fileStream = _tmp6_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (file);
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	journal_archiver_appendStringToArchiveFile (self, fileStream, "</body></html>");
	_g_object_unref0 (fileStream);
	_g_object_unref0 (file);
	_g_free0 (path);
}


static void journal_archiver_writeEntriesToArchiveFile (JournalArchiver* self) {
	gchar* path = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GFile* file = NULL;
	const gchar* _tmp7_ = NULL;
	GFile* _tmp8_ = NULL;
	GFileOutputStream* fileStream = NULL;
	GFileOutputStream* _tmp9_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = user_data_getArchiveDirPath ();
	path = _tmp0_;
	_tmp1_ = path;
	_tmp2_ = self->priv->_archiveFilePath;
	_tmp3_ = file_utility_pathCombine (_tmp1_, _tmp2_);
	_g_free0 (path);
	path = _tmp3_;
	_tmp4_ = self->priv->_archiveFilePath;
	_tmp5_ = g_strconcat ("Hello. The filename is: ", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	zystem_debug (_tmp6_);
	_g_free0 (_tmp6_);
	_tmp7_ = path;
	_tmp8_ = g_file_new_for_path (_tmp7_);
	file = _tmp8_;
	_tmp9_ = g_file_append_to (file, G_FILE_CREATE_NONE, NULL, &_inner_error_);
	fileStream = _tmp9_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (file);
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		GeeIterator* _yearEntry_it = NULL;
		GeeMap* _tmp10_ = NULL;
		GeeSet* _tmp11_ = NULL;
		GeeSet* _tmp12_ = NULL;
		GeeSet* _tmp13_ = NULL;
		GeeIterator* _tmp14_ = NULL;
		GeeIterator* _tmp15_ = NULL;
		_tmp10_ = self->priv->yearFolders;
		_tmp11_ = gee_map_get_entries (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = _tmp12_;
		_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
		_tmp15_ = _tmp14_;
		_g_object_unref0 (_tmp13_);
		_yearEntry_it = _tmp15_;
		while (TRUE) {
			GeeIterator* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
			GeeMapEntry* yearEntry = NULL;
			GeeIterator* _tmp18_ = NULL;
			gpointer _tmp19_ = NULL;
			_tmp16_ = _yearEntry_it;
			_tmp17_ = gee_iterator_next (_tmp16_);
			if (!_tmp17_) {
				break;
			}
			_tmp18_ = _yearEntry_it;
			_tmp19_ = gee_iterator_get (_tmp18_);
			yearEntry = (GeeMapEntry*) _tmp19_;
			{
				GeeIterator* _monthEntry_it = NULL;
				GeeMapEntry* _tmp20_ = NULL;
				gconstpointer _tmp21_ = NULL;
				YearFolder* _tmp22_ = NULL;
				GeeMap* _tmp23_ = NULL;
				GeeMap* _tmp24_ = NULL;
				GeeSet* _tmp25_ = NULL;
				GeeSet* _tmp26_ = NULL;
				GeeSet* _tmp27_ = NULL;
				GeeIterator* _tmp28_ = NULL;
				GeeIterator* _tmp29_ = NULL;
				_tmp20_ = yearEntry;
				_tmp21_ = gee_map_entry_get_value (_tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = year_folder_get_monthMap ((YearFolder*) _tmp22_);
				_tmp24_ = _tmp23_;
				_tmp25_ = gee_map_get_entries (_tmp24_);
				_tmp26_ = _tmp25_;
				_tmp27_ = _tmp26_;
				_tmp28_ = gee_iterable_iterator ((GeeIterable*) _tmp27_);
				_tmp29_ = _tmp28_;
				_g_object_unref0 (_tmp27_);
				_monthEntry_it = _tmp29_;
				while (TRUE) {
					GeeIterator* _tmp30_ = NULL;
					gboolean _tmp31_ = FALSE;
					GeeMapEntry* monthEntry = NULL;
					GeeIterator* _tmp32_ = NULL;
					gpointer _tmp33_ = NULL;
					_tmp30_ = _monthEntry_it;
					_tmp31_ = gee_iterator_next (_tmp30_);
					if (!_tmp31_) {
						break;
					}
					_tmp32_ = _monthEntry_it;
					_tmp33_ = gee_iterator_get (_tmp32_);
					monthEntry = (GeeMapEntry*) _tmp33_;
					{
						GeeIterator* _entryEntry_it = NULL;
						GeeMapEntry* _tmp34_ = NULL;
						gconstpointer _tmp35_ = NULL;
						MonthFolder* _tmp36_ = NULL;
						GeeMap* _tmp37_ = NULL;
						GeeMap* _tmp38_ = NULL;
						GeeSet* _tmp39_ = NULL;
						GeeSet* _tmp40_ = NULL;
						GeeSet* _tmp41_ = NULL;
						GeeIterator* _tmp42_ = NULL;
						GeeIterator* _tmp43_ = NULL;
						_tmp34_ = monthEntry;
						_tmp35_ = gee_map_entry_get_value (_tmp34_);
						_tmp36_ = _tmp35_;
						_tmp37_ = month_folder_get_entryMap ((MonthFolder*) _tmp36_);
						_tmp38_ = _tmp37_;
						_tmp39_ = gee_map_get_entries (_tmp38_);
						_tmp40_ = _tmp39_;
						_tmp41_ = _tmp40_;
						_tmp42_ = gee_iterable_iterator ((GeeIterable*) _tmp41_);
						_tmp43_ = _tmp42_;
						_g_object_unref0 (_tmp41_);
						_entryEntry_it = _tmp43_;
						while (TRUE) {
							GeeIterator* _tmp44_ = NULL;
							gboolean _tmp45_ = FALSE;
							GeeMapEntry* entryEntry = NULL;
							GeeIterator* _tmp46_ = NULL;
							gpointer _tmp47_ = NULL;
							GeeMapEntry* _tmp48_ = NULL;
							gconstpointer _tmp49_ = NULL;
							JournalEntry* _tmp50_ = NULL;
							_tmp44_ = _entryEntry_it;
							_tmp45_ = gee_iterator_next (_tmp44_);
							if (!_tmp45_) {
								break;
							}
							_tmp46_ = _entryEntry_it;
							_tmp47_ = gee_iterator_get (_tmp46_);
							entryEntry = (GeeMapEntry*) _tmp47_;
							_tmp48_ = entryEntry;
							_tmp49_ = gee_map_entry_get_value (_tmp48_);
							_tmp50_ = _tmp49_;
							journal_archiver_writeJournalEntry (self, fileStream, (JournalEntry*) _tmp50_);
							_g_object_unref0 (entryEntry);
						}
						_g_object_unref0 (_entryEntry_it);
					}
					_g_object_unref0 (monthEntry);
				}
				_g_object_unref0 (_monthEntry_it);
			}
			_g_object_unref0 (yearEntry);
		}
		_g_object_unref0 (_yearEntry_it);
	}
	_g_object_unref0 (fileStream);
	_g_object_unref0 (file);
	_g_free0 (path);
}


static void journal_archiver_writeMonthlyEntriesToArchiveFile (JournalArchiver* self, MonthFolder* monthFolder) {
	gchar* path = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GFile* file = NULL;
	GFile* _tmp3_ = NULL;
	GFileOutputStream* fileStream = NULL;
	GFileOutputStream* _tmp4_ = NULL;
	gint x = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (monthFolder != NULL);
	_tmp0_ = journal_archiver_getMonthlyArchiveFilePath (self);
	path = _tmp0_;
	_tmp1_ = g_strconcat ("Hello. The path is THISSSSSS: ", path, NULL);
	_tmp2_ = _tmp1_;
	zystem_debug (_tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = g_file_new_for_path (path);
	file = _tmp3_;
	_tmp4_ = g_file_append_to (file, G_FILE_CREATE_NONE, NULL, &_inner_error_);
	fileStream = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (file);
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	x = 9 / 0;
	{
		GeeIterator* _entryEntry_it = NULL;
		MonthFolder* _tmp5_ = NULL;
		GeeMap* _tmp6_ = NULL;
		GeeMap* _tmp7_ = NULL;
		GeeSet* _tmp8_ = NULL;
		GeeSet* _tmp9_ = NULL;
		GeeSet* _tmp10_ = NULL;
		GeeIterator* _tmp11_ = NULL;
		GeeIterator* _tmp12_ = NULL;
		_tmp5_ = monthFolder;
		_tmp6_ = month_folder_get_entryMap (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = gee_map_get_entries (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = _tmp9_;
		_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
		_tmp12_ = _tmp11_;
		_g_object_unref0 (_tmp10_);
		_entryEntry_it = _tmp12_;
		while (TRUE) {
			GeeIterator* _tmp13_ = NULL;
			gboolean _tmp14_ = FALSE;
			GeeMapEntry* entryEntry = NULL;
			GeeIterator* _tmp15_ = NULL;
			gpointer _tmp16_ = NULL;
			GeeMapEntry* _tmp17_ = NULL;
			gconstpointer _tmp18_ = NULL;
			JournalEntry* _tmp19_ = NULL;
			gint _tmp20_ = 0;
			gint _tmp21_ = 0;
			gchar* _tmp22_ = NULL;
			gchar* _tmp23_ = NULL;
			GeeMapEntry* _tmp24_ = NULL;
			gconstpointer _tmp25_ = NULL;
			JournalEntry* _tmp26_ = NULL;
			_tmp13_ = _entryEntry_it;
			_tmp14_ = gee_iterator_next (_tmp13_);
			if (!_tmp14_) {
				break;
			}
			_tmp15_ = _entryEntry_it;
			_tmp16_ = gee_iterator_get (_tmp15_);
			entryEntry = (GeeMapEntry*) _tmp16_;
			_tmp17_ = entryEntry;
			_tmp18_ = gee_map_entry_get_value (_tmp17_);
			_tmp19_ = _tmp18_;
			_tmp20_ = journal_entry_get_day ((JournalEntry*) _tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_strdup_printf ("%i", _tmp21_);
			_tmp23_ = _tmp22_;
			zystem_debug (_tmp23_);
			_g_free0 (_tmp23_);
			_tmp24_ = entryEntry;
			_tmp25_ = gee_map_entry_get_value (_tmp24_);
			_tmp26_ = _tmp25_;
			journal_archiver_writeJournalEntry (self, fileStream, (JournalEntry*) _tmp26_);
			_g_object_unref0 (entryEntry);
		}
		_g_object_unref0 (_entryEntry_it);
	}
	_g_object_unref0 (fileStream);
	_g_object_unref0 (file);
	_g_free0 (path);
}


static gchar* journal_archiver_getMonthlyArchiveFilePath (JournalArchiver* self) {
	gchar* result = NULL;
	gchar* path = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = user_data_getArchiveDirPath ();
	path = _tmp0_;
	_tmp1_ = path;
	_tmp2_ = self->priv->_archiveDirPathMonthly;
	_tmp3_ = file_utility_pathCombine (_tmp1_, _tmp2_);
	_g_free0 (path);
	path = _tmp3_;
	_tmp4_ = path;
	_tmp5_ = self->priv->_archiveFilePathMonthly;
	_tmp6_ = file_utility_pathCombine (_tmp4_, _tmp5_);
	_g_free0 (path);
	path = _tmp6_;
	result = path;
	return result;
}


static void journal_archiver_setMonthlyArchiveDirPath (JournalArchiver* self, gint year) {
	GDateTime* dateTime = NULL;
	GDateTime* _tmp0_ = NULL;
	gchar* path = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_date_time_new_now_local ();
	dateTime = _tmp0_;
	_tmp1_ = g_date_time_format (dateTime, "%Y-%m-%d");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("MonthlyArchives_", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	path = _tmp4_;
	_tmp5_ = year;
	_tmp6_ = g_strdup_printf ("%i", _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = file_utility_pathCombine (path, _tmp7_);
	_tmp9_ = _tmp8_;
	journal_archiver_set_archiveDirPathMonthly (self, _tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_tmp10_ = user_data_getArchiveDirPath ();
	_tmp11_ = _tmp10_;
	_tmp12_ = self->priv->_archiveDirPathMonthly;
	_tmp13_ = file_utility_pathCombine (_tmp11_, _tmp12_);
	_tmp14_ = _tmp13_;
	file_utility_createFolder (_tmp14_);
	_g_free0 (_tmp14_);
	_g_free0 (_tmp11_);
	_g_free0 (path);
	_g_date_time_unref0 (dateTime);
}


static void journal_archiver_setMonthlyArchiveFilename (JournalArchiver* self, gint year, const gchar* month) {
	gchar* filename = NULL;
	gint _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (month != NULL);
	_tmp0_ = year;
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = month;
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp5_, "_Journal", NULL);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	_g_free0 (_tmp2_);
	filename = _tmp7_;
	_tmp8_ = self->priv->archiveType;
	if (g_strcmp0 (_tmp8_, "txt") == 0) {
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		_tmp9_ = filename;
		_tmp10_ = g_strconcat (_tmp9_, ".txt", NULL);
		_tmp11_ = _tmp10_;
		journal_archiver_set_archiveFilePathMonthly (self, _tmp11_);
		_g_free0 (_tmp11_);
	} else {
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		_tmp12_ = filename;
		_tmp13_ = g_strconcat (_tmp12_, ".html", NULL);
		_tmp14_ = _tmp13_;
		journal_archiver_set_archiveFilePathMonthly (self, _tmp14_);
		_g_free0 (_tmp14_);
	}
	_g_free0 (filename);
}


static void journal_archiver_setCompleteArchiveFilename (JournalArchiver* self) {
	gchar* filename = NULL;
	gchar* _tmp0_ = NULL;
	GDateTime* dateTime = NULL;
	GDateTime* _tmp1_ = NULL;
	gchar* timestamp = NULL;
	GDateTime* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("CompleteJournalArchive_");
	filename = _tmp0_;
	_tmp1_ = g_date_time_new_now_local ();
	dateTime = _tmp1_;
	_tmp2_ = dateTime;
	_tmp3_ = g_date_time_format (_tmp2_, "%Y-%m-%d");
	timestamp = _tmp3_;
	_tmp4_ = self->priv->archiveType;
	if (g_strcmp0 (_tmp4_, "txt") == 0) {
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		_tmp5_ = filename;
		_tmp6_ = timestamp;
		_tmp7_ = g_strconcat (_tmp5_, _tmp6_, NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat (_tmp8_, ".txt", NULL);
		_tmp10_ = _tmp9_;
		journal_archiver_set_archiveFilePath (self, _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
	} else {
		const gchar* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		_tmp11_ = filename;
		_tmp12_ = timestamp;
		_tmp13_ = g_strconcat (_tmp11_, _tmp12_, NULL);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strconcat (_tmp14_, ".html", NULL);
		_tmp16_ = _tmp15_;
		journal_archiver_set_archiveFilePath (self, _tmp16_);
		_g_free0 (_tmp16_);
		_g_free0 (_tmp14_);
	}
	_g_free0 (timestamp);
	_g_date_time_unref0 (dateTime);
	_g_free0 (filename);
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch22_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp6_ = regex;
		_tmp7_ = replacement;
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
		_tmp5_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch22_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp9_ = _tmp5_;
		_tmp5_ = NULL;
		result = _tmp9_;
		_g_free0 (_tmp5_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally22;
	__catch22_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally22:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void journal_archiver_writeJournalEntry (JournalArchiver* self, GFileOutputStream* fileStream, JournalEntry* entry) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (fileStream != NULL);
	g_return_if_fail (entry != NULL);
	_tmp0_ = self->priv->archiveType;
	if (g_strcmp0 (_tmp0_, "txt") == 0) {
		gchar* entryHeading = NULL;
		gchar* _tmp1_ = NULL;
		gchar* dateString = NULL;
		JournalEntry* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		JournalEntry* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		JournalEntry* _tmp18_ = NULL;
		gint _tmp19_ = 0;
		gint _tmp20_ = 0;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
		gchar* _tmp27_ = NULL;
		const gchar* _tmp28_ = NULL;
		gchar* _tmp29_ = NULL;
		const gchar* _tmp38_ = NULL;
		gchar* _tmp39_ = NULL;
		GFileOutputStream* _tmp40_ = NULL;
		const gchar* _tmp41_ = NULL;
		GFileOutputStream* _tmp42_ = NULL;
		JournalEntry* _tmp43_ = NULL;
		gchar* _tmp44_ = NULL;
		gchar* _tmp45_ = NULL;
		_tmp1_ = g_strdup ("\n\n-----------------------------------\n");
		entryHeading = _tmp1_;
		_tmp2_ = entry;
		_tmp3_ = journal_entry_get_year (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strdup_printf ("%i", _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strconcat (_tmp6_, "-", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = entry;
		_tmp10_ = journal_entry_get_month (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_strdup_printf ("%i", _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strconcat (_tmp8_, _tmp13_, NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strconcat (_tmp15_, "-", NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = entry;
		_tmp19_ = journal_entry_get_day (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_strdup_printf ("%i", _tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = g_strconcat (_tmp17_, _tmp22_, NULL);
		_tmp24_ = _tmp23_;
		_g_free0 (_tmp22_);
		_g_free0 (_tmp17_);
		_g_free0 (_tmp15_);
		_g_free0 (_tmp13_);
		_g_free0 (_tmp8_);
		_g_free0 (_tmp6_);
		dateString = _tmp24_;
		_tmp25_ = entryHeading;
		_tmp26_ = dateString;
		_tmp27_ = g_strconcat (_tmp25_, _tmp26_, NULL);
		_g_free0 (entryHeading);
		entryHeading = _tmp27_;
		_tmp28_ = entryHeading;
		_tmp29_ = g_strconcat (_tmp28_, "\n", NULL);
		_g_free0 (entryHeading);
		entryHeading = _tmp29_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp30_ = FALSE;
				_tmp30_ = TRUE;
				while (TRUE) {
					gint _tmp32_ = 0;
					const gchar* _tmp33_ = NULL;
					gint _tmp34_ = 0;
					gint _tmp35_ = 0;
					const gchar* _tmp36_ = NULL;
					gchar* _tmp37_ = NULL;
					if (!_tmp30_) {
						gint _tmp31_ = 0;
						_tmp31_ = i;
						i = _tmp31_ + 1;
					}
					_tmp30_ = FALSE;
					_tmp32_ = i;
					_tmp33_ = dateString;
					_tmp34_ = strlen (_tmp33_);
					_tmp35_ = _tmp34_;
					if (!(_tmp32_ < _tmp35_)) {
						break;
					}
					_tmp36_ = entryHeading;
					_tmp37_ = g_strconcat (_tmp36_, "-", NULL);
					_g_free0 (entryHeading);
					entryHeading = _tmp37_;
				}
			}
		}
		_tmp38_ = entryHeading;
		_tmp39_ = g_strconcat (_tmp38_, "\n\n", NULL);
		_g_free0 (entryHeading);
		entryHeading = _tmp39_;
		_tmp40_ = fileStream;
		_tmp41_ = entryHeading;
		journal_archiver_appendStringToArchiveFile (self, _tmp40_, _tmp41_);
		_tmp42_ = fileStream;
		_tmp43_ = entry;
		_tmp44_ = journal_entry_getFileContents (_tmp43_);
		_tmp45_ = _tmp44_;
		journal_archiver_appendStringToArchiveFile (self, _tmp42_, _tmp45_);
		_g_free0 (_tmp45_);
		_g_free0 (dateString);
		_g_free0 (entryHeading);
	} else {
		gchar* entryHtml = NULL;
		gchar* _tmp46_ = NULL;
		const gchar* _tmp47_ = NULL;
		JournalEntry* _tmp48_ = NULL;
		gint _tmp49_ = 0;
		gint _tmp50_ = 0;
		gchar* _tmp51_ = NULL;
		gchar* _tmp52_ = NULL;
		gchar* _tmp53_ = NULL;
		gchar* _tmp54_ = NULL;
		gchar* _tmp55_ = NULL;
		gchar* _tmp56_ = NULL;
		JournalEntry* _tmp57_ = NULL;
		gint _tmp58_ = 0;
		gint _tmp59_ = 0;
		gchar* _tmp60_ = NULL;
		gchar* _tmp61_ = NULL;
		gchar* _tmp62_ = NULL;
		gchar* _tmp63_ = NULL;
		gchar* _tmp64_ = NULL;
		gchar* _tmp65_ = NULL;
		JournalEntry* _tmp66_ = NULL;
		gint _tmp67_ = 0;
		gint _tmp68_ = 0;
		gchar* _tmp69_ = NULL;
		gchar* _tmp70_ = NULL;
		gchar* _tmp71_ = NULL;
		gchar* _tmp72_ = NULL;
		gchar* _tmp73_ = NULL;
		gchar* _tmp74_ = NULL;
		gchar* _tmp75_ = NULL;
		const gchar* _tmp76_ = NULL;
		JournalEntry* _tmp77_ = NULL;
		gchar* _tmp78_ = NULL;
		gchar* _tmp79_ = NULL;
		gchar* _tmp80_ = NULL;
		gchar* _tmp81_ = NULL;
		gchar* _tmp82_ = NULL;
		gchar* _tmp83_ = NULL;
		gchar* _tmp84_ = NULL;
		const gchar* _tmp85_ = NULL;
		gchar* _tmp86_ = NULL;
		GFileOutputStream* _tmp87_ = NULL;
		const gchar* _tmp88_ = NULL;
		_tmp46_ = g_strdup ("<div class='entry'>");
		entryHtml = _tmp46_;
		_tmp47_ = entryHtml;
		_tmp48_ = entry;
		_tmp49_ = journal_entry_get_year (_tmp48_);
		_tmp50_ = _tmp49_;
		_tmp51_ = g_strdup_printf ("%i", _tmp50_);
		_tmp52_ = _tmp51_;
		_tmp53_ = g_strconcat ("<div class='entryHeading'>", _tmp52_, NULL);
		_tmp54_ = _tmp53_;
		_tmp55_ = g_strconcat (_tmp54_, "-", NULL);
		_tmp56_ = _tmp55_;
		_tmp57_ = entry;
		_tmp58_ = journal_entry_get_month (_tmp57_);
		_tmp59_ = _tmp58_;
		_tmp60_ = g_strdup_printf ("%i", _tmp59_);
		_tmp61_ = _tmp60_;
		_tmp62_ = g_strconcat (_tmp56_, _tmp61_, NULL);
		_tmp63_ = _tmp62_;
		_tmp64_ = g_strconcat (_tmp63_, "-", NULL);
		_tmp65_ = _tmp64_;
		_tmp66_ = entry;
		_tmp67_ = journal_entry_get_day (_tmp66_);
		_tmp68_ = _tmp67_;
		_tmp69_ = g_strdup_printf ("%i", _tmp68_);
		_tmp70_ = _tmp69_;
		_tmp71_ = g_strconcat (_tmp65_, _tmp70_, NULL);
		_tmp72_ = _tmp71_;
		_tmp73_ = g_strconcat (_tmp72_, "</div>", NULL);
		_tmp74_ = _tmp73_;
		_tmp75_ = g_strconcat (_tmp47_, _tmp74_, NULL);
		_g_free0 (entryHtml);
		entryHtml = _tmp75_;
		_g_free0 (_tmp74_);
		_g_free0 (_tmp72_);
		_g_free0 (_tmp70_);
		_g_free0 (_tmp65_);
		_g_free0 (_tmp63_);
		_g_free0 (_tmp61_);
		_g_free0 (_tmp56_);
		_g_free0 (_tmp54_);
		_g_free0 (_tmp52_);
		_tmp76_ = entryHtml;
		_tmp77_ = entry;
		_tmp78_ = journal_entry_getFileContents (_tmp77_);
		_tmp79_ = _tmp78_;
		_tmp80_ = string_replace (_tmp79_, "\n", "<br />");
		_tmp81_ = _tmp80_;
		_tmp82_ = string_replace (_tmp81_, "<img class='dayjournalimage' src='../", "<img class='dayjournalimage' src='../../../");
		_tmp83_ = _tmp82_;
		_tmp84_ = g_strconcat (_tmp76_, _tmp83_, NULL);
		_g_free0 (entryHtml);
		entryHtml = _tmp84_;
		_g_free0 (_tmp83_);
		_g_free0 (_tmp81_);
		_g_free0 (_tmp79_);
		_tmp85_ = entryHtml;
		_tmp86_ = g_strconcat (_tmp85_, "</div>", NULL);
		_g_free0 (entryHtml);
		entryHtml = _tmp86_;
		_tmp87_ = fileStream;
		_tmp88_ = entryHtml;
		journal_archiver_appendStringToArchiveFile (self, _tmp87_, _tmp88_);
		_g_free0 (entryHtml);
	}
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static guint8* _vala_array_dup1 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


static guint8* _vala_array_dup2 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


static void journal_archiver_appendStringToArchiveFile (JournalArchiver* self, GFileOutputStream* fileStream, const gchar* text) {
	guint8* data = NULL;
	gint data_length1 = 0;
	gint _data_size_ = 0;
	const gchar* _tmp0_ = NULL;
	glong written = 0L;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (fileStream != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->archiveType;
	if (g_strcmp0 (_tmp0_, "html") == 0) {
		const gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		guint8* _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		guint8* _tmp5_ = NULL;
		gint _tmp5__length1 = 0;
		guint8* _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		_tmp1_ = text;
		_tmp2_ = string_replace (_tmp1_, "’", "&apos;");
		_tmp3_ = _tmp2_;
		_tmp4_ = string_get_data (_tmp3_, &_tmp4__length1);
		_tmp5_ = _tmp4_;
		_tmp5__length1 = _tmp4__length1;
		_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup1 (_tmp5_, _tmp5__length1) : ((gpointer) _tmp5_);
		_tmp6__length1 = _tmp5__length1;
		data = (g_free (data), NULL);
		data = _tmp6_;
		data_length1 = _tmp6__length1;
		_data_size_ = data_length1;
		_g_free0 (_tmp3_);
	} else {
		const gchar* _tmp7_ = NULL;
		guint8* _tmp8_ = NULL;
		gint _tmp8__length1 = 0;
		guint8* _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
		guint8* _tmp10_ = NULL;
		gint _tmp10__length1 = 0;
		_tmp7_ = text;
		_tmp8_ = string_get_data (_tmp7_, &_tmp8__length1);
		_tmp9_ = _tmp8_;
		_tmp9__length1 = _tmp8__length1;
		_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup2 (_tmp9_, _tmp9__length1) : ((gpointer) _tmp9_);
		_tmp10__length1 = _tmp9__length1;
		data = (g_free (data), NULL);
		data = _tmp10_;
		data_length1 = _tmp10__length1;
		_data_size_ = data_length1;
	}
	written = (glong) 0;
	while (TRUE) {
		glong _tmp11_ = 0L;
		guint8* _tmp12_ = NULL;
		gint _tmp12__length1 = 0;
		gssize _tmp13_ = 0L;
		GFileOutputStream* _tmp14_ = NULL;
		guint8* _tmp15_ = NULL;
		gint _tmp15__length1 = 0;
		glong _tmp16_ = 0L;
		guint8* _tmp17_ = NULL;
		gint _tmp17__length1 = 0;
		gssize _tmp18_ = 0L;
		glong _tmp19_ = 0L;
		_tmp11_ = written;
		_tmp12_ = data;
		_tmp12__length1 = data_length1;
		if (!(_tmp11_ < ((glong) _tmp12__length1))) {
			break;
		}
		_tmp14_ = fileStream;
		_tmp15_ = data;
		_tmp15__length1 = data_length1;
		_tmp16_ = written;
		_tmp17_ = data;
		_tmp17__length1 = data_length1;
		_tmp18_ = g_output_stream_write ((GOutputStream*) _tmp14_, _tmp15_ + ((gint) _tmp16_), (gsize) (_tmp17__length1 - ((gint) _tmp16_)), NULL, &_inner_error_);
		_tmp13_ = _tmp18_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			data = (g_free (data), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp19_ = written;
		written = _tmp19_ + _tmp13_;
	}
	data = (g_free (data), NULL);
}


const gchar* journal_archiver_get_archiveFilePath (JournalArchiver* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_archiveFilePath;
	result = _tmp0_;
	return result;
}


static void journal_archiver_set_archiveFilePath (JournalArchiver* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_archiveFilePath);
	self->priv->_archiveFilePath = _tmp1_;
	g_object_notify ((GObject *) self, "archiveFilePath");
}


const gchar* journal_archiver_get_archiveFilePathMonthly (JournalArchiver* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_archiveFilePathMonthly;
	result = _tmp0_;
	return result;
}


static void journal_archiver_set_archiveFilePathMonthly (JournalArchiver* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_archiveFilePathMonthly);
	self->priv->_archiveFilePathMonthly = _tmp1_;
	g_object_notify ((GObject *) self, "archiveFilePathMonthly");
}


const gchar* journal_archiver_get_archiveDirPathMonthly (JournalArchiver* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_archiveDirPathMonthly;
	result = _tmp0_;
	return result;
}


static void journal_archiver_set_archiveDirPathMonthly (JournalArchiver* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_archiveDirPathMonthly);
	self->priv->_archiveDirPathMonthly = _tmp1_;
	g_object_notify ((GObject *) self, "archiveDirPathMonthly");
}


static void journal_archiver_class_init (JournalArchiverClass * klass) {
	journal_archiver_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (JournalArchiverPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_journal_archiver_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_journal_archiver_set_property;
	G_OBJECT_CLASS (klass)->finalize = journal_archiver_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ARCHIVER_ARCHIVE_FILE_PATH, g_param_spec_string ("archiveFilePath", "archiveFilePath", "archiveFilePath", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ARCHIVER_ARCHIVE_FILE_PATH_MONTHLY, g_param_spec_string ("archiveFilePathMonthly", "archiveFilePathMonthly", "archiveFilePathMonthly", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), JOURNAL_ARCHIVER_ARCHIVE_DIR_PATH_MONTHLY, g_param_spec_string ("archiveDirPathMonthly", "archiveDirPathMonthly", "archiveDirPathMonthly", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void journal_archiver_instance_init (JournalArchiver * self) {
	self->priv = JOURNAL_ARCHIVER_GET_PRIVATE (self);
}


static void journal_archiver_finalize (GObject* obj) {
	JournalArchiver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_JOURNAL_ARCHIVER, JournalArchiver);
	_g_object_unref0 (self->priv->yearFolders);
	_g_free0 (self->priv->_archiveFilePath);
	_g_free0 (self->priv->_archiveFilePathMonthly);
	_g_free0 (self->priv->_archiveDirPathMonthly);
	_g_free0 (self->priv->archiveType);
	G_OBJECT_CLASS (journal_archiver_parent_class)->finalize (obj);
}


GType journal_archiver_get_type (void) {
	static volatile gsize journal_archiver_type_id__volatile = 0;
	if (g_once_init_enter (&journal_archiver_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (JournalArchiverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) journal_archiver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (JournalArchiver), 0, (GInstanceInitFunc) journal_archiver_instance_init, NULL };
		GType journal_archiver_type_id;
		journal_archiver_type_id = g_type_register_static (G_TYPE_OBJECT, "JournalArchiver", &g_define_type_info, 0);
		g_once_init_leave (&journal_archiver_type_id__volatile, journal_archiver_type_id);
	}
	return journal_archiver_type_id__volatile;
}


static void _vala_journal_archiver_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	JournalArchiver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_JOURNAL_ARCHIVER, JournalArchiver);
	switch (property_id) {
		case JOURNAL_ARCHIVER_ARCHIVE_FILE_PATH:
		g_value_set_string (value, journal_archiver_get_archiveFilePath (self));
		break;
		case JOURNAL_ARCHIVER_ARCHIVE_FILE_PATH_MONTHLY:
		g_value_set_string (value, journal_archiver_get_archiveFilePathMonthly (self));
		break;
		case JOURNAL_ARCHIVER_ARCHIVE_DIR_PATH_MONTHLY:
		g_value_set_string (value, journal_archiver_get_archiveDirPathMonthly (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_journal_archiver_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	JournalArchiver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_JOURNAL_ARCHIVER, JournalArchiver);
	switch (property_id) {
		case JOURNAL_ARCHIVER_ARCHIVE_FILE_PATH:
		journal_archiver_set_archiveFilePath (self, g_value_get_string (value));
		break;
		case JOURNAL_ARCHIVER_ARCHIVE_FILE_PATH_MONTHLY:
		journal_archiver_set_archiveFilePathMonthly (self, g_value_get_string (value));
		break;
		case JOURNAL_ARCHIVER_ARCHIVE_DIR_PATH_MONTHLY:
		journal_archiver_set_archiveDirPathMonthly (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


YearFolder* year_folder_construct (GType object_type, GFileInfo* fileInfo) {
	YearFolder * self = NULL;
	GFileInfo* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	GeeTreeMap* _tmp3_ = NULL;
	GeeTreeMap* _tmp4_ = NULL;
	g_return_val_if_fail (fileInfo != NULL, NULL);
	self = (YearFolder*) g_object_new (object_type, NULL);
	_tmp0_ = fileInfo;
	_tmp1_ = g_file_info_get_name (_tmp0_);
	_tmp2_ = atoi (_tmp1_);
	year_folder_set_year (self, _tmp2_);
	_tmp3_ = gee_tree_map_new (G_TYPE_INT, NULL, NULL, TYPE_MONTH_FOLDER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	_tmp4_ = _tmp3_;
	year_folder_set_monthMap (self, (GeeMap*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	return self;
}


YearFolder* year_folder_new (GFileInfo* fileInfo) {
	return year_folder_construct (TYPE_YEAR_FOLDER, fileInfo);
}


void year_folder_addMonth (YearFolder* self, gint monthNum, MonthFolder* monthFolder) {
	GeeMap* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	MonthFolder* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (monthFolder != NULL);
	_tmp0_ = self->priv->_monthMap;
	_tmp1_ = monthNum;
	_tmp2_ = monthFolder;
	gee_map_set (_tmp0_, (gpointer) ((gintptr) _tmp1_), _tmp2_);
}


gint year_folder_get_year (YearFolder* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_year;
	result = _tmp0_;
	return result;
}


static void year_folder_set_year (YearFolder* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_year = _tmp0_;
	g_object_notify ((GObject *) self, "year");
}


GeeMap* year_folder_get_monthMap (YearFolder* self) {
	GeeMap* result;
	GeeMap* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_monthMap;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void year_folder_set_monthMap (YearFolder* self, GeeMap* value) {
	GeeMap* _tmp0_ = NULL;
	GeeMap* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_monthMap);
	self->priv->_monthMap = _tmp1_;
	g_object_notify ((GObject *) self, "monthMap");
}


static void year_folder_class_init (YearFolderClass * klass) {
	year_folder_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (YearFolderPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_year_folder_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_year_folder_set_property;
	G_OBJECT_CLASS (klass)->finalize = year_folder_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), YEAR_FOLDER_YEAR, g_param_spec_int ("year", "year", "year", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), YEAR_FOLDER_MONTH_MAP, g_param_spec_object ("monthMap", "monthMap", "monthMap", GEE_TYPE_MAP, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void year_folder_instance_init (YearFolder * self) {
	self->priv = YEAR_FOLDER_GET_PRIVATE (self);
}


static void year_folder_finalize (GObject* obj) {
	YearFolder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_YEAR_FOLDER, YearFolder);
	_g_object_unref0 (self->priv->_monthMap);
	G_OBJECT_CLASS (year_folder_parent_class)->finalize (obj);
}


/**
 * YearFolder class
 **************************************/
GType year_folder_get_type (void) {
	static volatile gsize year_folder_type_id__volatile = 0;
	if (g_once_init_enter (&year_folder_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (YearFolderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) year_folder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (YearFolder), 0, (GInstanceInitFunc) year_folder_instance_init, NULL };
		GType year_folder_type_id;
		year_folder_type_id = g_type_register_static (G_TYPE_OBJECT, "YearFolder", &g_define_type_info, 0);
		g_once_init_leave (&year_folder_type_id__volatile, year_folder_type_id);
	}
	return year_folder_type_id__volatile;
}


static void _vala_year_folder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	YearFolder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_YEAR_FOLDER, YearFolder);
	switch (property_id) {
		case YEAR_FOLDER_YEAR:
		g_value_set_int (value, year_folder_get_year (self));
		break;
		case YEAR_FOLDER_MONTH_MAP:
		g_value_set_object (value, year_folder_get_monthMap (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_year_folder_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	YearFolder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_YEAR_FOLDER, YearFolder);
	switch (property_id) {
		case YEAR_FOLDER_YEAR:
		year_folder_set_year (self, g_value_get_int (value));
		break;
		case YEAR_FOLDER_MONTH_MAP:
		year_folder_set_monthMap (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


MonthFolder* month_folder_construct (GType object_type, GFileInfo* fileInfo) {
	MonthFolder * self = NULL;
	GeeTreeMap* _tmp0_ = NULL;
	GeeTreeMap* _tmp1_ = NULL;
	GFileInfo* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	g_return_val_if_fail (fileInfo != NULL, NULL);
	self = (MonthFolder*) g_object_new (object_type, NULL);
	_tmp0_ = gee_tree_map_new (G_TYPE_INT, NULL, NULL, TYPE_JOURNAL_ENTRY, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	_tmp1_ = _tmp0_;
	month_folder_set_entryMap (self, (GeeMap*) _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = fileInfo;
	_tmp3_ = g_file_info_get_name (_tmp2_);
	_tmp4_ = atoi (_tmp3_);
	month_folder_set_month (self, _tmp4_);
	return self;
}


MonthFolder* month_folder_new (GFileInfo* fileInfo) {
	return month_folder_construct (TYPE_MONTH_FOLDER, fileInfo);
}


void month_folder_addEntry (MonthFolder* self, gint day, JournalEntry* entry) {
	GeeMap* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	JournalEntry* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry != NULL);
	_tmp0_ = self->priv->_entryMap;
	_tmp1_ = day;
	_tmp2_ = entry;
	gee_map_set (_tmp0_, (gpointer) ((gintptr) _tmp1_), _tmp2_);
}


gint month_folder_get_month (MonthFolder* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_month;
	result = _tmp0_;
	return result;
}


static void month_folder_set_month (MonthFolder* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_month = _tmp0_;
	g_object_notify ((GObject *) self, "month");
}


GeeMap* month_folder_get_entryMap (MonthFolder* self) {
	GeeMap* result;
	GeeMap* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_entryMap;
	result = _tmp0_;
	return result;
}


static void month_folder_set_entryMap (MonthFolder* self, GeeMap* value) {
	GeeMap* _tmp0_ = NULL;
	GeeMap* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_entryMap);
	self->priv->_entryMap = _tmp1_;
	g_object_notify ((GObject *) self, "entryMap");
}


static void month_folder_class_init (MonthFolderClass * klass) {
	month_folder_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MonthFolderPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_month_folder_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_month_folder_set_property;
	G_OBJECT_CLASS (klass)->finalize = month_folder_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONTH_FOLDER_MONTH, g_param_spec_int ("month", "month", "month", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MONTH_FOLDER_ENTRY_MAP, g_param_spec_object ("entryMap", "entryMap", "entryMap", GEE_TYPE_MAP, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void month_folder_instance_init (MonthFolder * self) {
	self->priv = MONTH_FOLDER_GET_PRIVATE (self);
}


static void month_folder_finalize (GObject* obj) {
	MonthFolder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MONTH_FOLDER, MonthFolder);
	_g_object_unref0 (self->priv->_entryMap);
	G_OBJECT_CLASS (month_folder_parent_class)->finalize (obj);
}


/**
 * MonthFolder class
 ***************************************/
GType month_folder_get_type (void) {
	static volatile gsize month_folder_type_id__volatile = 0;
	if (g_once_init_enter (&month_folder_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MonthFolderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) month_folder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MonthFolder), 0, (GInstanceInitFunc) month_folder_instance_init, NULL };
		GType month_folder_type_id;
		month_folder_type_id = g_type_register_static (G_TYPE_OBJECT, "MonthFolder", &g_define_type_info, 0);
		g_once_init_leave (&month_folder_type_id__volatile, month_folder_type_id);
	}
	return month_folder_type_id__volatile;
}


static void _vala_month_folder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MonthFolder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MONTH_FOLDER, MonthFolder);
	switch (property_id) {
		case MONTH_FOLDER_MONTH:
		g_value_set_int (value, month_folder_get_month (self));
		break;
		case MONTH_FOLDER_ENTRY_MAP:
		g_value_set_object (value, month_folder_get_entryMap (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_month_folder_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MonthFolder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MONTH_FOLDER, MonthFolder);
	switch (property_id) {
		case MONTH_FOLDER_MONTH:
		month_folder_set_month (self, g_value_get_int (value));
		break;
		case MONTH_FOLDER_ENTRY_MAP:
		month_folder_set_entryMap (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



