/* UserData.c generated by valac 0.30.0, the Vala compiler
 * generated from UserData.vala, do not modify */

/*
 * DayJournal
 *
 * Copyright (C) 2013 Zach Burnham <thejambi@gmail.com>
 *
 * DayJournal is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * DayJournal is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <libnotify/notify.h>


#define TYPE_USER_DATA (user_data_get_type ())
#define USER_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_DATA, UserData))
#define USER_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_DATA, UserDataClass))
#define IS_USER_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_DATA))
#define IS_USER_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_DATA))
#define USER_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_DATA, UserDataClass))

typedef struct _UserData UserData;
typedef struct _UserDataClass UserDataClass;
typedef struct _UserDataPrivate UserDataPrivate;

#define TYPE_USER_SETTINGS_MANAGER (user_settings_manager_get_type ())
#define USER_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_SETTINGS_MANAGER, UserSettingsManager))
#define USER_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerClass))
#define IS_USER_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_SETTINGS_MANAGER))
#define IS_USER_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_SETTINGS_MANAGER))
#define USER_SETTINGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_SETTINGS_MANAGER, UserSettingsManagerClass))

typedef struct _UserSettingsManager UserSettingsManager;
typedef struct _UserSettingsManagerClass UserSettingsManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _UserData {
	GObject parent_instance;
	UserDataPrivate * priv;
};

struct _UserDataClass {
	GObjectClass parent_class;
};


static gpointer user_data_parent_class = NULL;
static gchar* user_data__homeDirPath;
static gchar* user_data__homeDirPath = NULL;
static gchar* user_data__defaultDjDirName;
static gchar* user_data__defaultDjDirName = NULL;
static gchar* user_data__djDirPath;
static gchar* user_data__djDirPath = NULL;
static gchar* user_data__importJournalPath;
static gchar* user_data__importJournalPath = NULL;
static gchar* user_data__blipDirPath;
static gchar* user_data__blipDirPath = NULL;
static gint64 user_data__lastBlipLoadDate;
static gint64 user_data__lastBlipLoadDate = 0LL;
static gboolean user_data__lockPastEntries;
static gboolean user_data__lockPastEntries = FALSE;
static gboolean user_data__seldomSave;
static gboolean user_data__seldomSave = FALSE;
static gchar* user_data__newEntrySectionText;
static gchar* user_data__newEntrySectionText = NULL;
static gint user_data__windowWidth;
static gint user_data__windowWidth = 550;
static gint user_data__windowHeight;
static gint user_data__windowHeight = 430;
static gint user_data__fontSize;
static gint user_data__fontSize = 10;
static gint user_data__calendarFontSize;
static gint user_data__calendarFontSize = 0;
static gboolean user_data__rememberCurrentJournalAfterInit;
static gboolean user_data__rememberCurrentJournalAfterInit = FALSE;
static gchar* user_data__fontString;
static gchar* user_data__fontString = NULL;
static UserSettingsManager* user_data_settings;
static UserSettingsManager* user_data_settings = NULL;

GType user_data_get_type (void) G_GNUC_CONST;
enum  {
	USER_DATA_DUMMY_PROPERTY
};
GType user_settings_manager_get_type (void) G_GNUC_CONST;
#define USER_DATA_defaultFontSize 10
void user_data_initializeUserData (void);
const gchar* user_data_get_defaultDjDirName (void);
static void user_data_set_defaultDjDirName (const gchar* value);
gboolean user_data_get_seldomSave (void);
void user_data_set_seldomSave (gboolean value);
const gchar* user_data_get_homeDirPath (void);
static void user_data_set_homeDirPath (const gchar* value);
void zystem_debug (const gchar* s);
UserSettingsManager* user_settings_manager_new (void);
UserSettingsManager* user_settings_manager_construct (GType object_type);
const gchar* user_data_get_importJournalPath (void);
void user_data_setCurrentJournalAsImportJournal (void);
gint user_data_get_calendarFontSize (void);
void user_data_set_calendarFontSize (gint value);
const gchar* user_data_get_blipDirPath (void);
static void user_data_loadBlipDir (void);
gboolean user_data_get_rememberCurrentJournalAfterInit (void);
void user_data_rememberCurrentJournal (void);
gchar* file_utility_pathCombine (const gchar* pathStart, const gchar* pathEnd);
gboolean file_utility_isDirectory (const gchar* path);
gchar* blip_loader_decideWhichBlipDirToUse (const gchar* dir1, const gchar* dir2);
void user_data_set_blipDirPath (const gchar* value);
void user_settings_manager_setString (UserSettingsManager* self, const gchar* key, const gchar* val);
#define USER_SETTINGS_MANAGER_blipDirKey "blipDirectory"
void user_data_setDjDir (const gchar* path);
const gchar* user_data_get_djDirPath (void);
void user_data_set_djDirPath (const gchar* value);
void user_settings_manager_setDjDir (UserSettingsManager* self, const gchar* path);
gchar* user_data_getDefaultDjDir (void);
gchar* user_data_getNewEntrySectionText (void);
gchar* blip_data_amOrPm (GDateTime* dateTime);
void user_data_setLockPastEntries (gboolean lockEm);
void user_settings_manager_setLockPastEntries (UserSettingsManager* self, gboolean lockEm);
gboolean user_data_get_lockPastEntries (void);
void user_data_set_lockPastEntries (gboolean value);
void user_data_saveWindowSize (gint width, gint height);
gint user_data_get_windowWidth (void);
void user_settings_manager_setInt (UserSettingsManager* self, const gchar* key, gint val);
#define USER_SETTINGS_MANAGER_windowWidthKey "width"
gint user_data_get_windowHeight (void);
#define USER_SETTINGS_MANAGER_windowHeightKey "height"
void user_data_saveCalendarFontSize (gint size);
#define USER_SETTINGS_MANAGER_calendarFontSizeKey "calFontSize"
gchar* user_data_getArchiveDirPath (void);
void user_data_deleteUISettings (void);
void user_settings_manager_deleteUISettings (UserSettingsManager* self);
void user_settings_manager_addJournal (UserSettingsManager* self, const gchar* name, const gchar* path);
void user_data_forgetCurrentJournal (void);
void user_settings_manager_removeJournal (UserSettingsManager* self, const gchar* name);
void user_data_set_importJournalPath (const gchar* value);
#define USER_SETTINGS_MANAGER_importJournalDirKey "importJournalDirectory"
void user_data_setNoImportJournal (void);
#define USER_SETTINGS_MANAGER_NONE "NONE"
gboolean user_data_currentJournalIsImportJournal (void);
GeeArrayList* user_data_getJournalList (void);
GeeArrayList* user_settings_manager_getJournalList (UserSettingsManager* self);
void user_data_setLastBlipLoadDateToYesterday (void);
#define USER_SETTINGS_MANAGER_lastBlipLoadDateKey "lastBlipLoadDate"
void user_data_setLastBlipLoadDate (GDateTime* time);
void user_data_showNotification (const gchar* title, const gchar* message);
gchar* user_data_getDayOneEntriesDir (void);
gchar* user_data_getDayOnePhotosDir (void);
void user_data_setFont (const gchar* fontStr);
#define USER_SETTINGS_MANAGER_fontKey "font"
const gchar* user_data_get_fontString (void);
void user_data_set_fontString (const gchar* value);
UserData* user_data_new (void);
UserData* user_data_construct (GType object_type);
gint64 user_data_get_lastBlipLoadDate (void);
void user_data_set_lastBlipLoadDate (gint64 value);
const gchar* user_data_get_newEntrySectionText (void);
void user_data_set_newEntrySectionText (const gchar* value);
void user_data_set_windowWidth (gint value);
void user_data_set_windowHeight (gint value);
gint user_data_get_fontSize (void);
void user_data_set_fontSize (gint value);
void user_data_set_rememberCurrentJournalAfterInit (gboolean value);
static void user_data_finalize (GObject* obj);
static void _vala_user_data_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_user_data_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


void user_data_initializeUserData (void) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	UserSettingsManager* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	const gchar* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	const gchar* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	gchar* _tmp27_ = NULL;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	_tmp0_ = user_data_get_defaultDjDirName ();
	_tmp1_ = _tmp0_;
	user_data_set_defaultDjDirName ("DayJournal");
	_tmp2_ = user_data_get_seldomSave ();
	_tmp3_ = _tmp2_;
	user_data_set_seldomSave (FALSE);
	_tmp4_ = user_data_get_homeDirPath ();
	_tmp5_ = _tmp4_;
	_tmp6_ = g_get_home_dir ();
	user_data_set_homeDirPath (_tmp6_);
	zystem_debug ("Loading settings...");
	_tmp7_ = user_settings_manager_new ();
	_g_object_unref0 (user_data_settings);
	user_data_settings = _tmp7_;
	_tmp9_ = user_data_get_importJournalPath ();
	_tmp10_ = _tmp9_;
	if (_tmp10_ == NULL) {
		_tmp8_ = TRUE;
	} else {
		const gchar* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		_tmp11_ = user_data_get_importJournalPath ();
		_tmp12_ = _tmp11_;
		_tmp8_ = g_strcmp0 (_tmp12_, "") == 0;
	}
	if (_tmp8_) {
		user_data_setCurrentJournalAsImportJournal ();
	}
	zystem_debug ("Done Loading settings...");
	_tmp13_ = user_data_get_calendarFontSize ();
	_tmp14_ = _tmp13_;
	if (_tmp14_ < 4) {
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		GtkCalendar* _tmp17_ = NULL;
		GtkCalendar* _tmp18_ = NULL;
		PangoContext* _tmp19_ = NULL;
		PangoFontDescription* _tmp20_ = NULL;
		gint _tmp21_ = 0;
		_tmp15_ = user_data_get_calendarFontSize ();
		_tmp16_ = _tmp15_;
		_tmp17_ = (GtkCalendar*) gtk_calendar_new ();
		g_object_ref_sink (_tmp17_);
		_tmp18_ = _tmp17_;
		_tmp19_ = gtk_widget_get_pango_context ((GtkWidget*) _tmp18_);
		_tmp20_ = pango_context_get_font_description (_tmp19_);
		_tmp21_ = pango_font_description_get_size (_tmp20_);
		user_data_set_calendarFontSize (_tmp21_ / PANGO_SCALE);
		_g_object_unref0 (_tmp18_);
	}
	_tmp22_ = user_data_get_blipDirPath ();
	_tmp23_ = _tmp22_;
	if (g_strcmp0 (_tmp23_, "") == 0) {
		user_data_loadBlipDir ();
	}
	_tmp24_ = user_data_get_importJournalPath ();
	_tmp25_ = _tmp24_;
	_tmp26_ = g_strconcat ("Import? ", _tmp25_, NULL);
	_tmp27_ = _tmp26_;
	zystem_debug (_tmp27_);
	_g_free0 (_tmp27_);
	_tmp28_ = user_data_get_rememberCurrentJournalAfterInit ();
	_tmp29_ = _tmp28_;
	if (_tmp29_) {
		user_data_rememberCurrentJournal ();
	}
}


static void user_data_loadBlipDir (void) {
	gboolean hasDbxBlipJournal = FALSE;
	gboolean hasU1BlipJournal = FALSE;
	gchar* blipPathDbx = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	gchar* blipPathU1 = NULL;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	UserSettingsManager* _tmp41_ = NULL;
	const gchar* _tmp42_ = NULL;
	const gchar* _tmp43_ = NULL;
	hasDbxBlipJournal = FALSE;
	hasU1BlipJournal = FALSE;
	_tmp0_ = user_data_get_homeDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = file_utility_pathCombine (_tmp1_, "Dropbox");
	blipPathDbx = _tmp2_;
	_tmp3_ = blipPathDbx;
	_tmp4_ = file_utility_pathCombine (_tmp3_, "Apps");
	_tmp5_ = _tmp4_;
	_tmp6_ = file_utility_pathCombine (_tmp5_, "Blip Journal");
	_g_free0 (blipPathDbx);
	blipPathDbx = _tmp6_;
	_g_free0 (_tmp5_);
	_tmp7_ = blipPathDbx;
	_tmp8_ = file_utility_isDirectory (_tmp7_);
	if (_tmp8_) {
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		hasDbxBlipJournal = TRUE;
		_tmp9_ = blipPathDbx;
		_tmp10_ = g_strconcat ("YAYYYYYYYYYYYYYY Dropbox Blip dir path found: ", _tmp9_, NULL);
		_tmp11_ = _tmp10_;
		zystem_debug (_tmp11_);
		_g_free0 (_tmp11_);
	}
	_tmp12_ = user_data_get_homeDirPath ();
	_tmp13_ = _tmp12_;
	_tmp14_ = file_utility_pathCombine (_tmp13_, "Ubuntu One");
	blipPathU1 = _tmp14_;
	_tmp15_ = blipPathU1;
	_tmp16_ = file_utility_pathCombine (_tmp15_, ".Blip Journal");
	_g_free0 (blipPathU1);
	blipPathU1 = _tmp16_;
	_tmp17_ = blipPathU1;
	_tmp18_ = file_utility_isDirectory (_tmp17_);
	if (_tmp18_) {
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		hasU1BlipJournal = TRUE;
		_tmp19_ = blipPathU1;
		_tmp20_ = g_strconcat ("U1 Blip Journal path: ", _tmp19_, NULL);
		_tmp21_ = _tmp20_;
		zystem_debug (_tmp21_);
		_g_free0 (_tmp21_);
	}
	_tmp23_ = hasDbxBlipJournal;
	if (_tmp23_) {
		gboolean _tmp24_ = FALSE;
		_tmp24_ = hasU1BlipJournal;
		_tmp22_ = _tmp24_;
	} else {
		_tmp22_ = FALSE;
	}
	if (_tmp22_) {
		const gchar* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
		const gchar* _tmp27_ = NULL;
		const gchar* _tmp28_ = NULL;
		gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
		_tmp25_ = user_data_get_blipDirPath ();
		_tmp26_ = _tmp25_;
		_tmp27_ = blipPathDbx;
		_tmp28_ = blipPathU1;
		_tmp29_ = blip_loader_decideWhichBlipDirToUse (_tmp27_, _tmp28_);
		_tmp30_ = _tmp29_;
		user_data_set_blipDirPath (_tmp30_);
		_g_free0 (_tmp30_);
	} else {
		gboolean _tmp31_ = FALSE;
		_tmp31_ = hasDbxBlipJournal;
		if (_tmp31_) {
			const gchar* _tmp32_ = NULL;
			const gchar* _tmp33_ = NULL;
			const gchar* _tmp34_ = NULL;
			_tmp32_ = user_data_get_blipDirPath ();
			_tmp33_ = _tmp32_;
			_tmp34_ = blipPathDbx;
			user_data_set_blipDirPath (_tmp34_);
		} else {
			gboolean _tmp35_ = FALSE;
			_tmp35_ = hasU1BlipJournal;
			if (_tmp35_) {
				const gchar* _tmp36_ = NULL;
				const gchar* _tmp37_ = NULL;
				const gchar* _tmp38_ = NULL;
				_tmp36_ = user_data_get_blipDirPath ();
				_tmp37_ = _tmp36_;
				_tmp38_ = blipPathU1;
				user_data_set_blipDirPath (_tmp38_);
			} else {
				const gchar* _tmp39_ = NULL;
				const gchar* _tmp40_ = NULL;
				_tmp39_ = user_data_get_blipDirPath ();
				_tmp40_ = _tmp39_;
				user_data_set_blipDirPath ("");
			}
		}
	}
	_tmp41_ = user_data_settings;
	_tmp42_ = user_data_get_blipDirPath ();
	_tmp43_ = _tmp42_;
	user_settings_manager_setString (_tmp41_, USER_SETTINGS_MANAGER_blipDirKey, _tmp43_);
	_g_free0 (blipPathU1);
	_g_free0 (blipPathDbx);
}


void user_data_setDjDir (const gchar* path) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	UserSettingsManager* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	g_return_if_fail (path != NULL);
	zystem_debug ("Setting DayJournal directory");
	_tmp0_ = user_data_get_djDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = path;
	user_data_set_djDirPath (_tmp2_);
	_tmp3_ = user_data_settings;
	_tmp4_ = path;
	user_settings_manager_setDjDir (_tmp3_, _tmp4_);
}


gchar* user_data_getDefaultDjDir (void) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	_tmp0_ = user_data_get_homeDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = user_data_get_defaultDjDirName ();
	_tmp3_ = _tmp2_;
	_tmp4_ = file_utility_pathCombine (_tmp1_, _tmp3_);
	result = _tmp4_;
	return result;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


gchar* user_data_getNewEntrySectionText (void) {
	gchar* result = NULL;
	GDateTime* dateTime = NULL;
	GDateTime* _tmp0_ = NULL;
	gchar* newSectionText = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	_tmp0_ = g_date_time_new_now_local ();
	dateTime = _tmp0_;
	_tmp1_ = g_date_time_format (dateTime, "%l:%M");
	_tmp2_ = _tmp1_;
	_tmp3_ = string_strip (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat ("\n\n", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = blip_data_amOrPm (dateTime);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp6_, _tmp8_, NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strconcat (_tmp10_, " |  ", NULL);
	_tmp12_ = _tmp11_;
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	newSectionText = _tmp12_;
	result = newSectionText;
	_g_date_time_unref0 (dateTime);
	return result;
}


void user_data_setLockPastEntries (gboolean lockEm) {
	UserSettingsManager* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	_tmp0_ = user_data_settings;
	_tmp1_ = lockEm;
	user_settings_manager_setLockPastEntries (_tmp0_, _tmp1_);
	_tmp2_ = user_data_get_lockPastEntries ();
	_tmp3_ = _tmp2_;
	_tmp4_ = lockEm;
	user_data_set_lockPastEntries (_tmp4_);
}


void user_data_saveWindowSize (gint width, gint height) {
	gint _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	_tmp0_ = width;
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (_tmp2_, " and the height: ", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = height;
	_tmp6_ = g_strdup_printf ("%i", _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat (_tmp4_, _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	zystem_debug (_tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp10_ = user_data_get_windowWidth ();
	_tmp11_ = _tmp10_;
	_tmp12_ = width;
	if (_tmp11_ != _tmp12_) {
		UserSettingsManager* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		_tmp13_ = user_data_settings;
		_tmp14_ = width;
		user_settings_manager_setInt (_tmp13_, USER_SETTINGS_MANAGER_windowWidthKey, _tmp14_);
	}
	_tmp15_ = user_data_get_windowHeight ();
	_tmp16_ = _tmp15_;
	_tmp17_ = height;
	if (_tmp16_ != _tmp17_) {
		UserSettingsManager* _tmp18_ = NULL;
		gint _tmp19_ = 0;
		_tmp18_ = user_data_settings;
		_tmp19_ = height;
		user_settings_manager_setInt (_tmp18_, USER_SETTINGS_MANAGER_windowHeightKey, _tmp19_);
	}
}


void user_data_saveCalendarFontSize (gint size) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	_tmp0_ = user_data_get_calendarFontSize ();
	_tmp1_ = _tmp0_;
	_tmp2_ = size;
	if (_tmp1_ != _tmp2_) {
		UserSettingsManager* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		_tmp3_ = user_data_settings;
		_tmp4_ = size;
		user_settings_manager_setInt (_tmp3_, USER_SETTINGS_MANAGER_calendarFontSizeKey, _tmp4_);
	}
}


gchar* user_data_getArchiveDirPath (void) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	_tmp0_ = user_data_get_djDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = file_utility_pathCombine (_tmp1_, "Journal Archives");
	result = _tmp2_;
	return result;
}


void user_data_deleteUISettings (void) {
	UserSettingsManager* _tmp0_ = NULL;
	_tmp0_ = user_data_settings;
	user_settings_manager_deleteUISettings (_tmp0_);
}


void user_data_rememberCurrentJournal (void) {
	UserSettingsManager* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	_tmp0_ = user_data_settings;
	_tmp1_ = user_data_get_djDirPath ();
	_tmp2_ = _tmp1_;
	_tmp3_ = user_data_get_djDirPath ();
	_tmp4_ = _tmp3_;
	user_settings_manager_addJournal (_tmp0_, _tmp2_, _tmp4_);
}


void user_data_forgetCurrentJournal (void) {
	UserSettingsManager* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	_tmp0_ = user_data_settings;
	_tmp1_ = user_data_get_djDirPath ();
	_tmp2_ = _tmp1_;
	user_settings_manager_removeJournal (_tmp0_, _tmp2_);
}


void user_data_setCurrentJournalAsImportJournal (void) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	UserSettingsManager* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	_tmp0_ = user_data_get_importJournalPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = user_data_get_djDirPath ();
	_tmp3_ = _tmp2_;
	user_data_set_importJournalPath (_tmp3_);
	_tmp4_ = user_data_settings;
	_tmp5_ = user_data_get_djDirPath ();
	_tmp6_ = _tmp5_;
	user_settings_manager_setString (_tmp4_, USER_SETTINGS_MANAGER_importJournalDirKey, _tmp6_);
}


void user_data_setNoImportJournal (void) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	UserSettingsManager* _tmp2_ = NULL;
	_tmp0_ = user_data_get_importJournalPath ();
	_tmp1_ = _tmp0_;
	user_data_set_importJournalPath (USER_SETTINGS_MANAGER_NONE);
	_tmp2_ = user_data_settings;
	user_settings_manager_setString (_tmp2_, USER_SETTINGS_MANAGER_importJournalDirKey, USER_SETTINGS_MANAGER_NONE);
}


gboolean user_data_currentJournalIsImportJournal (void) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	_tmp0_ = user_data_get_djDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = user_data_get_importJournalPath ();
	_tmp3_ = _tmp2_;
	result = g_strcmp0 (_tmp1_, _tmp3_) == 0;
	return result;
}


GeeArrayList* user_data_getJournalList (void) {
	GeeArrayList* result = NULL;
	UserSettingsManager* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	_tmp0_ = user_data_settings;
	_tmp1_ = user_settings_manager_getJournalList (_tmp0_);
	result = _tmp1_;
	return result;
}


void user_data_setLastBlipLoadDateToYesterday (void) {
	GDateTime* today = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* time = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GDateTime* _tmp4_ = NULL;
	gchar* timeStr = NULL;
	gint64 _tmp5_ = 0LL;
	gchar* _tmp6_ = NULL;
	UserSettingsManager* _tmp7_ = NULL;
	_tmp0_ = g_date_time_new_now_local ();
	today = _tmp0_;
	_tmp1_ = g_date_time_get_year (today);
	_tmp2_ = g_date_time_get_month (today);
	_tmp3_ = g_date_time_get_day_of_month (today);
	_tmp4_ = g_date_time_new_local (_tmp1_, _tmp2_, _tmp3_, 0, 0, (gdouble) 0);
	time = _tmp4_;
	_tmp5_ = g_date_time_to_unix (time);
	_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp5_);
	timeStr = _tmp6_;
	_tmp7_ = user_data_settings;
	user_settings_manager_setString (_tmp7_, USER_SETTINGS_MANAGER_lastBlipLoadDateKey, timeStr);
	_g_free0 (timeStr);
	_g_date_time_unref0 (time);
	_g_date_time_unref0 (today);
}


void user_data_setLastBlipLoadDate (GDateTime* time) {
	gchar* timeStr = NULL;
	GDateTime* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	gchar* _tmp2_ = NULL;
	UserSettingsManager* _tmp3_ = NULL;
	g_return_if_fail (time != NULL);
	_tmp0_ = time;
	_tmp1_ = g_date_time_to_unix (_tmp0_);
	_tmp2_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp1_);
	timeStr = _tmp2_;
	_tmp3_ = user_data_settings;
	user_settings_manager_setString (_tmp3_, USER_SETTINGS_MANAGER_lastBlipLoadDateKey, timeStr);
	_g_free0 (timeStr);
}


void user_data_showNotification (const gchar* title, const gchar* message) {
	NotifyNotification* notification = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	NotifyNotification* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (title != NULL);
	g_return_if_fail (message != NULL);
	notify_init ("DayJournal");
	_tmp0_ = title;
	_tmp1_ = message;
	_tmp2_ = notify_notification_new (_tmp0_, _tmp1_, "dayjournal");
	notification = _tmp2_;
	notify_notification_show (notification, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (notification);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (notification);
}


gchar* user_data_getDayOneEntriesDir (void) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	_tmp0_ = user_data_get_homeDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = file_utility_pathCombine (_tmp1_, "Dropbox/Apps/Day One/Journal.dayone/entries");
	result = _tmp2_;
	return result;
}


gchar* user_data_getDayOnePhotosDir (void) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	_tmp0_ = user_data_get_homeDirPath ();
	_tmp1_ = _tmp0_;
	_tmp2_ = file_utility_pathCombine (_tmp1_, "Dropbox/Apps/Day One/Journal.dayone/photos");
	result = _tmp2_;
	return result;
}


void user_data_setFont (const gchar* fontStr) {
	UserSettingsManager* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	g_return_if_fail (fontStr != NULL);
	_tmp0_ = user_data_settings;
	_tmp1_ = fontStr;
	user_settings_manager_setString (_tmp0_, USER_SETTINGS_MANAGER_fontKey, _tmp1_);
	_tmp2_ = user_data_get_fontString ();
	_tmp3_ = _tmp2_;
	_tmp4_ = fontStr;
	user_data_set_fontString (_tmp4_);
}


UserData* user_data_construct (GType object_type) {
	UserData * self = NULL;
	self = (UserData*) g_object_new (object_type, NULL);
	return self;
}


UserData* user_data_new (void) {
	return user_data_construct (TYPE_USER_DATA);
}


const gchar* user_data_get_homeDirPath (void) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	_tmp0_ = user_data__homeDirPath;
	result = _tmp0_;
	return result;
}


static void user_data_set_homeDirPath (const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__homeDirPath);
	user_data__homeDirPath = _tmp1_;
}


const gchar* user_data_get_defaultDjDirName (void) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	_tmp0_ = user_data__defaultDjDirName;
	result = _tmp0_;
	return result;
}


static void user_data_set_defaultDjDirName (const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__defaultDjDirName);
	user_data__defaultDjDirName = _tmp1_;
}


const gchar* user_data_get_djDirPath (void) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	_tmp0_ = user_data__djDirPath;
	result = _tmp0_;
	return result;
}


void user_data_set_djDirPath (const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__djDirPath);
	user_data__djDirPath = _tmp1_;
}


const gchar* user_data_get_importJournalPath (void) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	_tmp0_ = user_data__importJournalPath;
	result = _tmp0_;
	return result;
}


void user_data_set_importJournalPath (const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__importJournalPath);
	user_data__importJournalPath = _tmp1_;
}


const gchar* user_data_get_blipDirPath (void) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	_tmp0_ = user_data__blipDirPath;
	result = _tmp0_;
	return result;
}


void user_data_set_blipDirPath (const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__blipDirPath);
	user_data__blipDirPath = _tmp1_;
}


gint64 user_data_get_lastBlipLoadDate (void) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	_tmp0_ = user_data__lastBlipLoadDate;
	result = _tmp0_;
	return result;
}


void user_data_set_lastBlipLoadDate (gint64 value) {
	gint64 _tmp0_ = 0LL;
	_tmp0_ = value;
	user_data__lastBlipLoadDate = _tmp0_;
}


gboolean user_data_get_lockPastEntries (void) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	_tmp0_ = user_data__lockPastEntries;
	result = _tmp0_;
	return result;
}


void user_data_set_lockPastEntries (gboolean value) {
	gboolean _tmp0_ = FALSE;
	_tmp0_ = value;
	user_data__lockPastEntries = _tmp0_;
}


gboolean user_data_get_seldomSave (void) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	_tmp0_ = user_data__seldomSave;
	result = _tmp0_;
	return result;
}


void user_data_set_seldomSave (gboolean value) {
	gboolean _tmp0_ = FALSE;
	_tmp0_ = value;
	user_data__seldomSave = _tmp0_;
}


const gchar* user_data_get_newEntrySectionText (void) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	_tmp0_ = user_data__newEntrySectionText;
	result = _tmp0_;
	return result;
}


void user_data_set_newEntrySectionText (const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__newEntrySectionText);
	user_data__newEntrySectionText = _tmp1_;
}


gint user_data_get_windowWidth (void) {
	gint result;
	gint _tmp0_ = 0;
	_tmp0_ = user_data__windowWidth;
	result = _tmp0_;
	return result;
}


void user_data_set_windowWidth (gint value) {
	gint _tmp0_ = 0;
	_tmp0_ = value;
	user_data__windowWidth = _tmp0_;
}


gint user_data_get_windowHeight (void) {
	gint result;
	gint _tmp0_ = 0;
	_tmp0_ = user_data__windowHeight;
	result = _tmp0_;
	return result;
}


void user_data_set_windowHeight (gint value) {
	gint _tmp0_ = 0;
	_tmp0_ = value;
	user_data__windowHeight = _tmp0_;
}


gint user_data_get_fontSize (void) {
	gint result;
	gint _tmp0_ = 0;
	_tmp0_ = user_data__fontSize;
	result = _tmp0_;
	return result;
}


void user_data_set_fontSize (gint value) {
	gint _tmp0_ = 0;
	_tmp0_ = value;
	user_data__fontSize = _tmp0_;
}


gint user_data_get_calendarFontSize (void) {
	gint result;
	gint _tmp0_ = 0;
	_tmp0_ = user_data__calendarFontSize;
	result = _tmp0_;
	return result;
}


void user_data_set_calendarFontSize (gint value) {
	gint _tmp0_ = 0;
	_tmp0_ = value;
	user_data__calendarFontSize = _tmp0_;
}


gboolean user_data_get_rememberCurrentJournalAfterInit (void) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	_tmp0_ = user_data__rememberCurrentJournalAfterInit;
	result = _tmp0_;
	return result;
}


void user_data_set_rememberCurrentJournalAfterInit (gboolean value) {
	gboolean _tmp0_ = FALSE;
	_tmp0_ = value;
	user_data__rememberCurrentJournalAfterInit = _tmp0_;
}


const gchar* user_data_get_fontString (void) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	_tmp0_ = user_data__fontString;
	result = _tmp0_;
	return result;
}


void user_data_set_fontString (const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (user_data__fontString);
	user_data__fontString = _tmp1_;
}


static void user_data_class_init (UserDataClass * klass) {
	gchar* _tmp0_ = NULL;
	user_data_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_user_data_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_user_data_set_property;
	G_OBJECT_CLASS (klass)->finalize = user_data_finalize;
	_tmp0_ = g_strdup ("");
	user_data__fontString = _tmp0_;
}


static void user_data_instance_init (UserData * self) {
}


static void user_data_finalize (GObject* obj) {
	UserData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_DATA, UserData);
	G_OBJECT_CLASS (user_data_parent_class)->finalize (obj);
}


GType user_data_get_type (void) {
	static volatile gsize user_data_type_id__volatile = 0;
	if (g_once_init_enter (&user_data_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserData), 0, (GInstanceInitFunc) user_data_instance_init, NULL };
		GType user_data_type_id;
		user_data_type_id = g_type_register_static (G_TYPE_OBJECT, "UserData", &g_define_type_info, 0);
		g_once_init_leave (&user_data_type_id__volatile, user_data_type_id);
	}
	return user_data_type_id__volatile;
}


static void _vala_user_data_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	UserData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_DATA, UserData);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_user_data_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	UserData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_DATA, UserData);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



